/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "applet.override"
#include <Python.h>
#include <panel-applet.h>
#include <bonobo/bonobo-ui-util.h>

#include "pygobject.h"
#line 14 "applet.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGtkEventBox_Type;
#define PyGtkEventBox_Type (*_PyGtkEventBox_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyPanelApplet_Type;


/* ----------- PanelApplet ----------- */

static int
_wrap_panel_applet_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":PanelApplet.__init__", kwlist))
        return -1;
    self->obj = (GObject *)panel_applet_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create PanelApplet object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_panel_applet_get_size(PyGObject *self)
{
    int ret;

    ret = panel_applet_get_size(PANEL_APPLET(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_panel_applet_get_preferences_key(PyGObject *self)
{
    gchar *ret;

    ret = panel_applet_get_preferences_key(PANEL_APPLET(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_panel_applet_add_preferences(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "schema_dir", NULL };
    char *schema_dir;
    GError *opt_error = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:PanelApplet.add_preferences", kwlist, &schema_dir))
        return NULL;
    panel_applet_add_preferences(PANEL_APPLET(self->obj), schema_dir, &opt_error);
    if (pyg_error_check(&opt_error))
        return NULL;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_panel_applet_get_control(PyGObject *self)
{
    BonoboControl *ret;

    ret = panel_applet_get_control(PANEL_APPLET(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_panel_applet_get_popup_component(PyGObject *self)
{
    BonoboUIComponent *ret;

    ret = panel_applet_get_popup_component(PANEL_APPLET(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

#line 114 "applet.override"
static PyObject *
_wrap_panel_applet_setup_menu (PyGObject * self,
			       PyObject *  args,
			       PyObject *  kwargs)
{
    static char *kwlist[] = { "xml", "list", "extra_data", NULL };
    gchar *             xml;
    PyObject *          list;
    PyObject *          params = NULL;
    BonoboUIComponent * popup_component;
    int                 len, i;
    PyObject *          item;
    char *              cname;
    PyObject *          callback;
    
    if (!PyArg_ParseTupleAndKeywords (args, kwargs,
				      "sO|O:PanelApplet.setup_menu", 
				      kwlist, &xml, &list, &params)) {
	return NULL;
    }

    if (!PySequence_Check (list)) {
	PyErr_SetString (PyExc_TypeError, "entries must be a sequence");
	return NULL;
    }
    
    /* Copied from panel-applet.c */
    popup_component = panel_applet_get_popup_component (PANEL_APPLET (self->obj));
	    
    bonobo_ui_component_set (popup_component, "/", "<popups/>", NULL);
 
    bonobo_ui_component_set_translate (popup_component, "/popups", xml, NULL);
    /* end copy */
    
    len = PySequence_Size (list);
    for (i = 0; i < len; i++) {
	item = PySequence_GetItem (list, i);
	Py_DECREF (item);
	
	if (!PyArg_ParseTuple (item, "sO", &cname, &callback)) {
	    return NULL;
	}

	bonobo_ui_component_add_verb_full (popup_component, cname,
					   pyg_closure_new (callback, params, NULL));
    }

    Py_INCREF(Py_None);
    return Py_None;
}
#line 158 "applet.c"


#line 166 "applet.override"
static PyObject *
_wrap_panel_applet_setup_menu_from_file (PyGObject * self,
					 PyObject *  args,
					 PyObject *  kwargs)
{
    static char *kwlist[] = { "opt_datadir", "file", "opt_app_name", "list", "extra_data", NULL };
    gchar *             opt_datadir;
    gchar *             file;
    gchar *             opt_app_name;
    PyObject *          list;
    PyObject *          params = NULL;
    BonoboUIComponent * popup_component;
    gchar *             app_name = NULL;
    int                 len, i;
    PyObject *          item;
    char *              cname;
    PyObject *          callback;
    
    if (!PyArg_ParseTupleAndKeywords (args, kwargs,
				      "zszO|O:PanelApplet.setup_menu_from_file", 
				      kwlist, &opt_datadir, &file, &opt_app_name, &list, &params)) {
	return NULL;
    }

    if (!PySequence_Check (list)) {
	PyErr_SetString (PyExc_TypeError, "entries must be a sequence");
	return NULL;
    }
    
    /* Copied from panel-applet.c */
    if (!opt_app_name)
	opt_app_name = app_name = g_strdup_printf ("%d", getpid ());

    popup_component = panel_applet_get_popup_component (PANEL_APPLET (self->obj));

    bonobo_ui_util_set_ui (popup_component, opt_datadir, file, opt_app_name, NULL);
    /* end copy */
    
    len = PySequence_Size (list);
    for (i = 0; i < len; i++) {
	item = PySequence_GetItem (list, i);
	Py_DECREF (item);
	
	if (!PyArg_ParseTuple (item, "sO", &cname, &callback)) {
	    return NULL;
	}

	bonobo_ui_component_add_verb_full (popup_component, cname,
					   pyg_closure_new (callback, params, NULL));
    }
    
    if (app_name) {
	g_free (app_name);
    }
    
    Py_INCREF(Py_None);
    return Py_None;
}
#line 220 "applet.c"


static PyMethodDef _PyPanelApplet_methods[] = {
    { "get_size", (PyCFunction)_wrap_panel_applet_get_size, METH_NOARGS },
    { "get_preferences_key", (PyCFunction)_wrap_panel_applet_get_preferences_key, METH_NOARGS },
    { "add_preferences", (PyCFunction)_wrap_panel_applet_add_preferences, METH_VARARGS|METH_KEYWORDS },
    { "get_control", (PyCFunction)_wrap_panel_applet_get_control, METH_NOARGS },
    { "get_popup_component", (PyCFunction)_wrap_panel_applet_get_popup_component, METH_NOARGS },
    { "setup_menu", (PyCFunction)_wrap_panel_applet_setup_menu, METH_VARARGS|METH_KEYWORDS },
    { "setup_menu_from_file", (PyCFunction)_wrap_panel_applet_setup_menu_from_file, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyPanelApplet_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.applet.Applet",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyPanelApplet_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_panel_applet_new,		/* tp_init */
};



/* ----------- functions ----------- */

#line 19 "applet.override"
static PyObject*
_wrap_panel_applet_factory_main_closure (PyGObject * self,
			                 PyObject *  args,
					 PyObject * kwargs)
{
    static char *kwlist[] = { "iid", "applet_type", "func", "extra_data", NULL };
    gchar *iid;
    PyObject *pytype;
    PyObject *callback;
    PyObject *params = NULL;
    GType type;
    int retval;
    
    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "sOO|O:PanelAppletFactory.__init__",
				     kwlist, &iid, &pytype, &callback, &params)) {
        return NULL;
    }

    if (!PyCallable_Check (callback)) {
        PyErr_SetString (PyExc_TypeError, "second arg not callable");
	return NULL;
    }
    
    type = pyg_type_from_object (pytype);
    
    retval = panel_applet_factory_main_closure (iid,
    	     				       	type,
                                                pyg_closure_new (callback, params, NULL));
    return PyInt_FromLong (retval);
}
#line 311 "applet.c"


#line 52 "applet.override"
static PyObject *
_wrap_panel__applet_bonobo_factory (PyGObject * self,
 			            PyObject *  args,
				    PyObject * kwargs)
{
	static char *kwlist[] = { "iid", "type", "name", "version", "func", "extra_data", NULL };
	gchar *iid;
	PyObject *pytype;
	gchar *name;
	gchar *version;
	PyObject *callback;
	PyObject *params = NULL;
	GType type;
	PyObject *av;
	int argc;
	char **argv;
	int i;
	
	if (!PyArg_ParseTupleAndKeywords(args, kwargs,
					 "sOssO|O:gnome.applet.bonobo_factory",
					 kwlist, &iid, &pytype, &name, &version, &callback, &params)) {
		return NULL;
	}
	
	if (!PyCallable_Check (callback)) {
		PyErr_SetString (PyExc_TypeError, "second arg not callable");
		return NULL;
	}
	
	type = pyg_type_from_object (pytype);
	
	/* get argc and argv */
	av = PySys_GetObject ("argv");
	argc = PyList_Size (av);
	argv = g_new (char *, argc);
	for (i = 0; i < argc; i++) {
		argv[i] = g_strdup (PyString_AsString (PyList_GetItem (av, i)));
	}
	
	gnome_program_init (name, version,     
			    LIBGNOMEUI_MODULE,             
			    argc, argv,                                         
			    GNOME_PARAM_NONE,
			    NULL);            

        panel_applet_factory_main_closure (iid,
	                                   type,
					   pyg_closure_new (callback, params, NULL));
	
	/* TODO: Check if it's really neccessary to set argc and argv here */
	PySys_SetArgv (argc, argv);
	if (argv != NULL) {
		for (i = 0; i < argc; i++)
			g_free (argv[i]);
		g_free (argv);
	}
	
	Py_INCREF (Py_None);
	return Py_None;
}
#line 375 "applet.c"


PyMethodDef pyapplet_functions[] = {
    { "factory_main", (PyCFunction)_wrap_panel_applet_factory_main_closure, METH_VARARGS|METH_KEYWORDS },
    { "bonobo_factory", (PyCFunction)_wrap_panel__applet_bonobo_factory, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

/* intialise stuff extension classes */
void
pyapplet_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }
    if ((module = PyImport_ImportModule("gtk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGtkEventBox_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "EventBox");
    } else {
        Py_FatalError("could not import gtk");
        return;
    }


#line 408 "applet.c"
    pygobject_register_class(d, "PanelApplet", PANEL_TYPE_APPLET, &PyPanelApplet_Type, Py_BuildValue("(O)", &PyGtkEventBox_Type));
}
