/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "gtkhtml2.override"
#include <Python.h>

#include "pygobject.h"
#include <libgtkhtml/gtkhtml.h>
#include <libgtkhtml/view/htmlselection.h>
#line 14 "gtkhtml2.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGtkLayout_Type;
#define PyGtkLayout_Type (*_PyGtkLayout_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyGtkHtmlContext_Type;
PyTypeObject PyHtmlView_Type;
PyTypeObject PyHtmlDocument_Type;
PyTypeObject PyHtmlStream_Type;


/* ----------- GtkHtmlContext ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

PyTypeObject PyGtkHtmlContext_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gtkhtml2.HtmlContext",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- HtmlView ----------- */

static int
_wrap_html_view_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":HtmlView.__init__", kwlist))
        return -1;
    self->obj = (GObject *)html_view_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create HtmlView object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_html_view_set_document(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "document", NULL };
    PyGObject *document;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:HtmlView.set_document", kwlist, &PyHtmlDocument_Type, &document))
        return NULL;
    html_view_set_document(HTML_VIEW(self->obj), HTML_DOCUMENT(document->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_view_jump_to_anchor(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "anchor", NULL };
    char *anchor;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:HtmlView.jump_to_anchor", kwlist, &anchor))
        return NULL;
    html_view_jump_to_anchor(HTML_VIEW(self->obj), anchor);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_view_get_magnification(PyGObject *self)
{
    double ret;

    ret = html_view_get_magnification(HTML_VIEW(self->obj));
    return PyFloat_FromDouble(ret);
}

static PyObject *
_wrap_html_view_set_magnification(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "magnification", NULL };
    double magnification;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "d:HtmlView.set_magnification", kwlist, &magnification))
        return NULL;
    html_view_set_magnification(HTML_VIEW(self->obj), magnification);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_view_zoom_in(PyGObject *self)
{
    html_view_zoom_in(HTML_VIEW(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_view_zoom_out(PyGObject *self)
{
    html_view_zoom_out(HTML_VIEW(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_view_zoom_reset(PyGObject *self)
{
    html_view_zoom_reset(HTML_VIEW(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyHtmlView_methods[] = {
    { "set_document", (PyCFunction)_wrap_html_view_set_document, METH_VARARGS|METH_KEYWORDS },
    { "jump_to_anchor", (PyCFunction)_wrap_html_view_jump_to_anchor, METH_VARARGS|METH_KEYWORDS },
    { "get_magnification", (PyCFunction)_wrap_html_view_get_magnification, METH_NOARGS },
    { "set_magnification", (PyCFunction)_wrap_html_view_set_magnification, METH_VARARGS|METH_KEYWORDS },
    { "zoom_in", (PyCFunction)_wrap_html_view_zoom_in, METH_NOARGS },
    { "zoom_out", (PyCFunction)_wrap_html_view_zoom_out, METH_NOARGS },
    { "zoom_reset", (PyCFunction)_wrap_html_view_zoom_reset, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyHtmlView_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gtkhtml2.View",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyHtmlView_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_html_view_new,		/* tp_init */
};



/* ----------- HtmlDocument ----------- */

static int
_wrap_html_document_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":HtmlDocument.__init__", kwlist))
        return -1;
    self->obj = (GObject *)html_document_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create HtmlDocument object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_html_document_open_stream(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "mime_type", NULL };
    char *mime_type;
    int ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:HtmlDocument.open_stream", kwlist, &mime_type))
        return NULL;
    ret = html_document_open_stream(HTML_DOCUMENT(self->obj), mime_type);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

#line 20 "gtkhtml2.override"
static PyObject *
_wrap_html_document_write_stream(PyGObject *self, PyObject *args,
				 PyObject *kwargs)
{
    static char *kwlist[] = { "buffer", "len", NULL };
    char *buffer;
    int len;

    /* tricky, allows user to override calculated text length. */
    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
				     "s#|i:HtmlDocument.write_stream", kwlist,
				     &buffer, &len, &len))
        return NULL;
    
    html_document_write_stream(HTML_DOCUMENT(self->obj), buffer, len);
    Py_INCREF(Py_None);
    return Py_None;
}
#line 285 "gtkhtml2.c"


static PyObject *
_wrap_html_document_close_stream(PyGObject *self)
{
    html_document_close_stream(HTML_DOCUMENT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_document_clear(PyGObject *self)
{
    html_document_clear(HTML_DOCUMENT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyHtmlDocument_methods[] = {
    { "open_stream", (PyCFunction)_wrap_html_document_open_stream, METH_VARARGS|METH_KEYWORDS },
    { "write_stream", (PyCFunction)_wrap_html_document_write_stream, METH_VARARGS|METH_KEYWORDS },
    { "close_stream", (PyCFunction)_wrap_html_document_close_stream, METH_NOARGS },
    { "clear", (PyCFunction)_wrap_html_document_clear, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyHtmlDocument_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gtkhtml2.Document",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyHtmlDocument_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_html_document_new,		/* tp_init */
};



/* ----------- HtmlStream ----------- */

#line 40 "gtkhtml2.override"
static PyObject *
_wrap_html_stream_write(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "buffer", "size", NULL };
    char *buffer;
    int size;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s#|i:HtmlStream.write",
				     kwlist, &buffer, &size, &size))
        return NULL;
    html_stream_write(HTML_STREAM(self->obj), buffer, size);
    Py_INCREF(Py_None);
    return Py_None;
}
#line 372 "gtkhtml2.c"


static PyObject *
_wrap_html_stream_close(PyGObject *self)
{
    html_stream_close(HTML_STREAM(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_stream_destroy(PyGObject *self)
{
    html_stream_destroy(HTML_STREAM(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_stream_get_written(PyGObject *self)
{
    int ret;

    ret = html_stream_get_written(HTML_STREAM(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_html_stream_cancel(PyGObject *self)
{
    html_stream_cancel(HTML_STREAM(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_stream_get_mime_type(PyGObject *self)
{
    const gchar *ret;

    ret = html_stream_get_mime_type(HTML_STREAM(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_stream_set_mime_type(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "mime_type", NULL };
    char *mime_type;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:HtmlStream.set_mime_type", kwlist, &mime_type))
        return NULL;
    html_stream_set_mime_type(HTML_STREAM(self->obj), mime_type);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyHtmlStream_methods[] = {
    { "write", (PyCFunction)_wrap_html_stream_write, METH_VARARGS|METH_KEYWORDS },
    { "close", (PyCFunction)_wrap_html_stream_close, METH_NOARGS },
    { "destroy", (PyCFunction)_wrap_html_stream_destroy, METH_NOARGS },
    { "get_written", (PyCFunction)_wrap_html_stream_get_written, METH_NOARGS },
    { "cancel", (PyCFunction)_wrap_html_stream_cancel, METH_NOARGS },
    { "get_mime_type", (PyCFunction)_wrap_html_stream_get_mime_type, METH_NOARGS },
    { "set_mime_type", (PyCFunction)_wrap_html_stream_set_mime_type, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyHtmlStream_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gtkhtml2.Stream",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyHtmlStream_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_gtk_html_context_get(PyObject *self)
{
    GtkHtmlContext *ret;

    ret = gtk_html_context_get();
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_html_selection_end(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", "event", NULL };
    PyGObject *view;
    GdkEvent *event = NULL;
    PyObject *py_event;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O:html_selection_end", kwlist, &PyHtmlView_Type, &view, &py_event))
        return NULL;
    if (pyg_boxed_check(py_event, GDK_TYPE_EVENT))
        event = pyg_boxed_get(py_event, GdkEvent);
    else {
        PyErr_SetString(PyExc_TypeError, "event should be a GdkEvent");
        return NULL;
    }
    html_selection_end(HTML_VIEW(view->obj), (GdkEventButton *)event);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_selection_update(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", "event", NULL };
    PyGObject *view;
    GdkEvent *event = NULL;
    PyObject *py_event;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O:html_selection_update", kwlist, &PyHtmlView_Type, &view, &py_event))
        return NULL;
    if (pyg_boxed_check(py_event, GDK_TYPE_EVENT))
        event = pyg_boxed_get(py_event, GdkEvent);
    else {
        PyErr_SetString(PyExc_TypeError, "event should be a GdkEvent");
        return NULL;
    }
    html_selection_update(HTML_VIEW(view->obj), (GdkEventMotion *)event);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_html_selection_clear(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", NULL };
    PyGObject *view;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:html_selection_clear", kwlist, &PyHtmlView_Type, &view))
        return NULL;
    html_selection_clear(HTML_VIEW(view->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

PyMethodDef pygtkhtml2_functions[] = {
    { "gtk_html_context_get", (PyCFunction)_wrap_gtk_html_context_get, METH_NOARGS },
    { "html_selection_end", (PyCFunction)_wrap_html_selection_end, METH_VARARGS|METH_KEYWORDS },
    { "html_selection_update", (PyCFunction)_wrap_html_selection_update, METH_VARARGS|METH_KEYWORDS },
    { "html_selection_clear", (PyCFunction)_wrap_html_selection_clear, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};


/* ----------- enums and flags ----------- */

void
pygtkhtml2_add_constants(PyObject *module, const gchar *strip_prefix)
{
    PyModule_AddIntConstant(module, pyg_constant_strip_prefix("HTML_DOCUMENT_STATE_DONE", strip_prefix), HTML_DOCUMENT_STATE_DONE);
    PyModule_AddIntConstant(module, pyg_constant_strip_prefix("HTML_DOCUMENT_STATE_PARSING", strip_prefix), HTML_DOCUMENT_STATE_PARSING);
}

/* intialise stuff extension classes */
void
pygtkhtml2_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }
    if ((module = PyImport_ImportModule("gtk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGtkLayout_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Layout");
    } else {
        Py_FatalError("could not import gtk");
        return;
    }


#line 596 "gtkhtml2.c"
    pygobject_register_class(d, "GtkHtmlContext", GTK_HTML_CONTEXT_TYPE, &PyGtkHtmlContext_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "HtmlView", HTML_TYPE_VIEW, &PyHtmlView_Type, Py_BuildValue("(O)", &PyGtkLayout_Type));
    pygobject_register_class(d, "HtmlDocument", HTML_TYPE_DOCUMENT, &PyHtmlDocument_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "HtmlStream", HTML_TYPE_STREAM, &PyHtmlStream_Type, Py_BuildValue("(O)", &PyGObject_Type));
}
