/* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 4 "ui.override"
#include <Python.h>

#include "pygobject.h"
#include <pygtk/pygtk.h>
#include <libgnomeui/libgnomeui.h>
/* #include <libgnomeui/gnome-appbar.h> */
#include <bonobo/bonobo-ui-type-builtins.h>
#define GNOME_TYPE_APP_BAR GNOME_TYPE_APPBAR
#define GNOME_APP_BAR GNOME_APPBAR
#line 18 "ui.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGtkObject_Type;
#define PyGtkObject_Type (*_PyGtkObject_Type)
static PyTypeObject *_PyGtkWidget_Type;
#define PyGtkWidget_Type (*_PyGtkWidget_Type)
static PyTypeObject *_PyGtkBin_Type;
#define PyGtkBin_Type (*_PyGtkBin_Type)
static PyTypeObject *_PyGtkContainer_Type;
#define PyGtkContainer_Type (*_PyGtkContainer_Type)
static PyTypeObject *_PyGtkHBox_Type;
#define PyGtkHBox_Type (*_PyGtkHBox_Type)
static PyTypeObject *_PyGtkVBox_Type;
#define PyGtkVBox_Type (*_PyGtkVBox_Type)
static PyTypeObject *_PyGtkWindow_Type;
#define PyGtkWindow_Type (*_PyGtkWindow_Type)
static PyTypeObject *_PyGtkDialog_Type;
#define PyGtkDialog_Type (*_PyGtkDialog_Type)
static PyTypeObject *_PyGtkButton_Type;
#define PyGtkButton_Type (*_PyGtkButton_Type)
static PyTypeObject *_PyGtkImage_Type;
#define PyGtkImage_Type (*_PyGtkImage_Type)
static PyTypeObject *_PyGtkMenu_Type;
#define PyGtkMenu_Type (*_PyGtkMenu_Type)
static PyTypeObject *_PyGtkMenuBar_Type;
#define PyGtkMenuBar_Type (*_PyGtkMenuBar_Type)
static PyTypeObject *_PyGtkToolbar_Type;
#define PyGtkToolbar_Type (*_PyGtkToolbar_Type)
static PyTypeObject *_PyGtkCombo_Type;
#define PyGtkCombo_Type (*_PyGtkCombo_Type)
static PyTypeObject *_PyGtkAdjustment_Type;
#define PyGtkAdjustment_Type (*_PyGtkAdjustment_Type)
static PyTypeObject *_PyGtkEditable_Type;
#define PyGtkEditable_Type (*_PyGtkEditable_Type)
static PyTypeObject *_PyGdkPixbuf_Type;
#define PyGdkPixbuf_Type (*_PyGdkPixbuf_Type)
static PyTypeObject *_PyGnomeCanvas_Type;
#define PyGnomeCanvas_Type (*_PyGnomeCanvas_Type)
static PyTypeObject *_PyGnomeCanvasItem_Type;
#define PyGnomeCanvasItem_Type (*_PyGnomeCanvasItem_Type)
static PyTypeObject *_PyBonoboDockItem_Type;
#define PyBonoboDockItem_Type (*_PyBonoboDockItem_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyGnomeAbout_Type;
PyTypeObject PyGnomeApp_Type;
PyTypeObject PyGnomeAppBar_Type;
PyTypeObject PyGnomeClient_Type;
PyTypeObject PyGnomeColorPicker_Type;
PyTypeObject PyGnomeDateEdit_Type;
PyTypeObject PyGnomeDialog_Type;
PyTypeObject PyGnomeDruid_Type;
PyTypeObject PyGnomeDruidPage_Type;
PyTypeObject PyGnomeDruidPageEdge_Type;
PyTypeObject PyGnomeDruidPageStandard_Type;
PyTypeObject PyGnomeEntry_Type;
PyTypeObject PyGnomeFileEntry_Type;
PyTypeObject PyGnomeFontPicker_Type;
PyTypeObject PyGnomeHRef_Type;
PyTypeObject PyGnomeIconEntry_Type;
PyTypeObject PyGnomeIconList_Type;
PyTypeObject PyGnomeIconSelection_Type;
PyTypeObject PyGnomeIconTextItem_Type;
PyTypeObject PyGnomeMDI_Type;
PyTypeObject PyGnomeMDIChild_Type;
PyTypeObject PyGnomeMDIGenericChild_Type;
PyTypeObject PyGnomeMessageBox_Type;
PyTypeObject PyGnomePixmap_Type;
PyTypeObject PyGnomePixmapEntry_Type;
PyTypeObject PyGnomePropertyBox_Type;
PyTypeObject PyGnomeScores_Type;


/* ----------- GnomeAbout ----------- */

#line 42 "ui.override"
static int
_wrap_gnome_about_new (PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char  *kwlist[] = { "name", "version", "copyright", "comments",
			       "authors", "documenters", "translator_credits",
			       "logo_pixbuf", NULL };
    
    char         *name, *version, *copyright, *comments;
    PyObject     *pyauthors;
    PyObject     *pydocumenters = Py_None;
    char        **translator_credits = NULL;
    PyGObject    *pypixbuf = NULL;
    int           n_authors;
    char        **authors;
    int           i;
    int           n_documenters;
    char        **documenters;
    GdkPixbuf    *pixbuf;
    
    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     "ssssO|OsO!:GnomeAbout.__init__", kwlist,
                                     &name, &version, &copyright, &comments,
				     &pyauthors, &pydocumenters,
				     &translator_credits, &PyGdkPixbuf_Type, &pypixbuf)) {
	return -1;
    }

    if (!PyList_Check(pyauthors) && !PyTuple_Check(pyauthors)) {
	PyErr_SetString(PyExc_TypeError, "5th argument not a tuple or list");
	return -1;
    }

    if (pydocumenters != Py_None && !PyList_Check(pydocumenters) && !PyTuple_Check(pydocumenters)) {
	PyErr_SetString(PyExc_TypeError, "6th argument not a tuple or list");
	return -1;
    }
    
    n_authors = PySequence_Length(pyauthors);
    authors = g_new(gchar *, n_authors + 1);
    for (i = 0; i < n_authors; i++) {
        PyObject *item = PySequence_GetItem(pyauthors, i);
        Py_DECREF(item); 
        authors[i] = PyString_AsString(item);
    }
    authors[n_authors] = NULL;
    
    if (pydocumenters != Py_None) {
	    n_documenters = PySequence_Length(pydocumenters);
	    documenters = g_new(gchar *, n_documenters + 1);
	    for (i = 0; i < n_documenters; i++) {
		    PyObject *item = PySequence_GetItem(pydocumenters, i);
		    Py_DECREF(item); 
		    documenters[i] = PyString_AsString(item);
	    }
	    documenters[n_documenters] = NULL;
    } else {
	    documenters = NULL;
    }

    if (pypixbuf != NULL) {
	pixbuf = GDK_PIXBUF(pypixbuf->obj);
    } else {
	pixbuf = NULL;
    }
    
    self->obj = (GObject*)gnome_about_new (name,
					   version,
					   copyright,
					   comments,
					   (const gchar**)authors,
					   (const gchar**)documenters,
					   (const gchar*)translator_credits,
					   pixbuf);
    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError,"could not create GnomeAbout object");
        return -1;
    }

    g_object_ref(self->obj); /* we don't own the first reference of windows */
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}
#line 181 "ui.c"


PyTypeObject PyGnomeAbout_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.About",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_about_new,		/* tp_init */
};



/* ----------- GnomeApp ----------- */

static int
_wrap_gnome_app_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "appname", "title", NULL };
    char *appname, *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeApp.__init__", kwlist, &appname, &title))
        return -1;
    self->obj = (GObject *)gnome_app_new(appname, title);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeApp object");
        return -1;
    }
    g_object_ref(self->obj); /* we don't own the first reference of windows */
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_app_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "appname", "title", NULL };
    char *appname, *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeApp.construct", kwlist, &appname, &title))
        return NULL;
    gnome_app_construct(GNOME_APP(self->obj), appname, title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_set_menus(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "menubar", NULL };
    PyGObject *menubar;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeApp.set_menus", kwlist, &PyGtkMenuBar_Type, &menubar))
        return NULL;
    gnome_app_set_menus(GNOME_APP(self->obj), GTK_MENU_BAR(menubar->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_set_toolbar(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "toolbar", NULL };
    PyGObject *toolbar;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeApp.set_toolbar", kwlist, &PyGtkToolbar_Type, &toolbar))
        return NULL;
    gnome_app_set_toolbar(GNOME_APP(self->obj), GTK_TOOLBAR(toolbar->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_set_statusbar(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "statusbar", NULL };
    PyGObject *statusbar;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeApp.set_statusbar", kwlist, &PyGtkWidget_Type, &statusbar))
        return NULL;
    gnome_app_set_statusbar(GNOME_APP(self->obj), GTK_WIDGET(statusbar->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_set_statusbar_custom(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "container", "statusbar", NULL };
    PyGObject *container, *statusbar;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O!:GnomeApp.set_statusbar_custom", kwlist, &PyGtkWidget_Type, &container, &PyGtkWidget_Type, &statusbar))
        return NULL;
    gnome_app_set_statusbar_custom(GNOME_APP(self->obj), GTK_WIDGET(container->obj), GTK_WIDGET(statusbar->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_set_contents(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "contents", NULL };
    PyGObject *contents;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeApp.set_contents", kwlist, &PyGtkWidget_Type, &contents))
        return NULL;
    gnome_app_set_contents(GNOME_APP(self->obj), GTK_WIDGET(contents->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_add_toolbar(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "toolbar", "name", "behavior", "placement", "band_num", "band_position", "offset", NULL };
    char *name;
    int band_num, band_position, offset;
    BonoboDockItemBehavior behavior;
    PyGObject *toolbar;
    BonoboDockPlacement placement;
    PyObject *py_behavior = NULL, *py_placement = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sOOiii:GnomeApp.add_toolbar", kwlist, &PyGtkToolbar_Type, &toolbar, &name, &py_behavior, &py_placement, &band_num, &band_position, &offset))
        return NULL;
    if (pyg_flags_get_value(BONOBO_TYPE_DOCK_ITEM_BEHAVIOR, py_behavior, (gint *)&behavior))
        return NULL;
    if (pyg_enum_get_value(BONOBO_TYPE_DOCK_PLACEMENT, py_placement, (gint *)&placement))
        return NULL;
    gnome_app_add_toolbar(GNOME_APP(self->obj), GTK_TOOLBAR(toolbar->obj), name, behavior, placement, band_num, band_position, offset);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_add_docked(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "widget", "name", "behavior", "placement", "band_num", "band_position", "offset", NULL };
    char *name;
    int band_num, band_position, offset;
    GtkWidget *ret;
    BonoboDockItemBehavior behavior;
    PyGObject *widget;
    BonoboDockPlacement placement;
    PyObject *py_behavior = NULL, *py_placement = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!sOOiii:GnomeApp.add_docked", kwlist, &PyGtkWidget_Type, &widget, &name, &py_behavior, &py_placement, &band_num, &band_position, &offset))
        return NULL;
    if (pyg_flags_get_value(BONOBO_TYPE_DOCK_ITEM_BEHAVIOR, py_behavior, (gint *)&behavior))
        return NULL;
    if (pyg_enum_get_value(BONOBO_TYPE_DOCK_PLACEMENT, py_placement, (gint *)&placement))
        return NULL;
    ret = gnome_app_add_docked(GNOME_APP(self->obj), GTK_WIDGET(widget->obj), name, behavior, placement, band_num, band_position, offset);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_app_add_dock_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "item", "placement", "band_num", "band_position", "offset", NULL };
    PyGObject *item;
    PyObject *py_placement = NULL;
    BonoboDockPlacement placement;
    int band_num, band_position, offset;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!Oiii:GnomeApp.add_dock_item", kwlist, &PyBonoboDockItem_Type, &item, &py_placement, &band_num, &band_position, &offset))
        return NULL;
    if (pyg_enum_get_value(BONOBO_TYPE_DOCK_PLACEMENT, py_placement, (gint *)&placement))
        return NULL;
    gnome_app_add_dock_item(GNOME_APP(self->obj), BONOBO_DOCK_ITEM(item->obj), placement, band_num, band_position, offset);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_enable_layout_config(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "enable", NULL };
    int enable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeApp.enable_layout_config", kwlist, &enable))
        return NULL;
    gnome_app_enable_layout_config(GNOME_APP(self->obj), enable);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_get_dock(PyGObject *self)
{
    BonoboDock *ret;

    ret = gnome_app_get_dock(GNOME_APP(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_app_get_dock_item_by_name(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;
    BonoboDockItem *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeApp.get_dock_item_by_name", kwlist, &name))
        return NULL;
    ret = gnome_app_get_dock_item_by_name(GNOME_APP(self->obj), name);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_app_remove_menus(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "items", NULL };
    char *path;
    int items;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si:GnomeApp.remove_menus", kwlist, &path, &items))
        return NULL;
    gnome_app_remove_menus(GNOME_APP(self->obj), path, items);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_remove_menu_range(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", "start", "items", NULL };
    char *path;
    int start, items;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sii:GnomeApp.remove_menu_range", kwlist, &path, &start, &items))
        return NULL;
    gnome_app_remove_menu_range(GNOME_APP(self->obj), path, start, items);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_flash(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "flash", NULL };
    char *flash;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeApp.flash", kwlist, &flash))
        return NULL;
    gnome_app_flash(GNOME_APP(self->obj), flash);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_error(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "error", NULL };
    char *error;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeApp.error", kwlist, &error))
        return NULL;
    ret = gnome_app_error(GNOME_APP(self->obj), error);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_app_warning(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "warning", NULL };
    char *warning;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeApp.warning", kwlist, &warning))
        return NULL;
    ret = gnome_app_warning(GNOME_APP(self->obj), warning);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyGnomeApp_methods[] = {
    { "construct", (PyCFunction)_wrap_gnome_app_construct, METH_VARARGS|METH_KEYWORDS },
    { "set_menus", (PyCFunction)_wrap_gnome_app_set_menus, METH_VARARGS|METH_KEYWORDS },
    { "set_toolbar", (PyCFunction)_wrap_gnome_app_set_toolbar, METH_VARARGS|METH_KEYWORDS },
    { "set_statusbar", (PyCFunction)_wrap_gnome_app_set_statusbar, METH_VARARGS|METH_KEYWORDS },
    { "set_statusbar_custom", (PyCFunction)_wrap_gnome_app_set_statusbar_custom, METH_VARARGS|METH_KEYWORDS },
    { "set_contents", (PyCFunction)_wrap_gnome_app_set_contents, METH_VARARGS|METH_KEYWORDS },
    { "add_toolbar", (PyCFunction)_wrap_gnome_app_add_toolbar, METH_VARARGS|METH_KEYWORDS },
    { "add_docked", (PyCFunction)_wrap_gnome_app_add_docked, METH_VARARGS|METH_KEYWORDS },
    { "add_dock_item", (PyCFunction)_wrap_gnome_app_add_dock_item, METH_VARARGS|METH_KEYWORDS },
    { "enable_layout_config", (PyCFunction)_wrap_gnome_app_enable_layout_config, METH_VARARGS|METH_KEYWORDS },
    { "get_dock", (PyCFunction)_wrap_gnome_app_get_dock, METH_NOARGS },
    { "get_dock_item_by_name", (PyCFunction)_wrap_gnome_app_get_dock_item_by_name, METH_VARARGS|METH_KEYWORDS },
    { "remove_menus", (PyCFunction)_wrap_gnome_app_remove_menus, METH_VARARGS|METH_KEYWORDS },
    { "remove_menu_range", (PyCFunction)_wrap_gnome_app_remove_menu_range, METH_VARARGS|METH_KEYWORDS },
    { "flash", (PyCFunction)_wrap_gnome_app_flash, METH_VARARGS|METH_KEYWORDS },
    { "error", (PyCFunction)_wrap_gnome_app_error, METH_VARARGS|METH_KEYWORDS },
    { "warning", (PyCFunction)_wrap_gnome_app_warning, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeApp_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.App",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeApp_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_app_new,		/* tp_init */
};



/* ----------- GnomeAppBar ----------- */

static int
_wrap_gnome_appbar_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "has_progress", "has_status", "interactivity", NULL };
    int has_progress, has_status;
    PyObject *py_interactivity = NULL;
    GnomePreferencesType interactivity;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iiO:GnomeAppBar.__init__", kwlist, &has_progress, &has_status, &py_interactivity))
        return -1;
    if (pyg_enum_get_value(GNOME_TYPE_PREFERENCES_TYPE, py_interactivity, (gint *)&interactivity))
        return -1;
    self->obj = (GObject *)gnome_appbar_new(has_progress, has_status, interactivity);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeAppBar object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_appbar_set_status(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "status", NULL };
    char *status;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeAppBar.set_status", kwlist, &status))
        return NULL;
    gnome_appbar_set_status(GNOME_APPBAR(self->obj), status);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_get_status(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_appbar_get_status(GNOME_APPBAR(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_appbar_set_default(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "default_status", NULL };
    char *default_status;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeAppBar.set_default", kwlist, &default_status))
        return NULL;
    gnome_appbar_set_default(GNOME_APPBAR(self->obj), default_status);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_push(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "status", NULL };
    char *status;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeAppBar.push", kwlist, &status))
        return NULL;
    gnome_appbar_push(GNOME_APPBAR(self->obj), status);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_pop(PyGObject *self)
{
    gnome_appbar_pop(GNOME_APPBAR(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_clear_stack(PyGObject *self)
{
    gnome_appbar_clear_stack(GNOME_APPBAR(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_set_progress_percentage(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "percentage", NULL };
    double percentage;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "d:GnomeAppBar.set_progress_percentage", kwlist, &percentage))
        return NULL;
    gnome_appbar_set_progress_percentage(GNOME_APPBAR(self->obj), percentage);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_get_progress(PyGObject *self)
{
    GtkProgressBar *ret;

    ret = gnome_appbar_get_progress(GNOME_APPBAR(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_appbar_refresh(PyGObject *self)
{
    gnome_appbar_refresh(GNOME_APPBAR(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_set_prompt(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "prompt", "modal", NULL };
    char *prompt;
    int modal;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si:GnomeAppBar.set_prompt", kwlist, &prompt, &modal))
        return NULL;
    gnome_appbar_set_prompt(GNOME_APPBAR(self->obj), prompt, modal);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_clear_prompt(PyGObject *self)
{
    gnome_appbar_clear_prompt(GNOME_APPBAR(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_appbar_get_response(PyGObject *self)
{
    gchar *ret;

    ret = gnome_appbar_get_response(GNOME_APPBAR(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeAppBar_methods[] = {
    { "set_status", (PyCFunction)_wrap_gnome_appbar_set_status, METH_VARARGS|METH_KEYWORDS },
    { "get_status", (PyCFunction)_wrap_gnome_appbar_get_status, METH_NOARGS },
    { "set_default", (PyCFunction)_wrap_gnome_appbar_set_default, METH_VARARGS|METH_KEYWORDS },
    { "push", (PyCFunction)_wrap_gnome_appbar_push, METH_VARARGS|METH_KEYWORDS },
    { "pop", (PyCFunction)_wrap_gnome_appbar_pop, METH_NOARGS },
    { "clear_stack", (PyCFunction)_wrap_gnome_appbar_clear_stack, METH_NOARGS },
    { "set_progress_percentage", (PyCFunction)_wrap_gnome_appbar_set_progress_percentage, METH_VARARGS|METH_KEYWORDS },
    { "get_progress", (PyCFunction)_wrap_gnome_appbar_get_progress, METH_NOARGS },
    { "refresh", (PyCFunction)_wrap_gnome_appbar_refresh, METH_NOARGS },
    { "set_prompt", (PyCFunction)_wrap_gnome_appbar_set_prompt, METH_VARARGS|METH_KEYWORDS },
    { "clear_prompt", (PyCFunction)_wrap_gnome_appbar_clear_prompt, METH_NOARGS },
    { "get_response", (PyCFunction)_wrap_gnome_appbar_get_response, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeAppBar_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.AppBar",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeAppBar_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_appbar_new,		/* tp_init */
};



/* ----------- GnomeClient ----------- */

static int
_wrap_gnome_client_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomeClient.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_client_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeClient object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_client_get_config_prefix(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_client_get_config_prefix(GNOME_CLIENT(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_get_global_config_prefix(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_client_get_global_config_prefix(GNOME_CLIENT(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_set_global_config_prefix(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "prefix", NULL };
    char *prefix;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeClient.set_global_config_prefix", kwlist, &prefix))
        return NULL;
    gnome_client_set_global_config_prefix(GNOME_CLIENT(self->obj), prefix);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_get_flags(PyGObject *self)
{
    guint ret;

    ret = gnome_client_get_flags(GNOME_CLIENT(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_client_set_restart_style(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "style", NULL };
    PyObject *py_style = NULL;
    GnomeRestartStyle style;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeClient.set_restart_style", kwlist, &py_style))
        return NULL;
    if (pyg_enum_get_value(GNOME_TYPE_RESTART_STYLE, py_style, (gint *)&style))
        return NULL;
    gnome_client_set_restart_style(GNOME_CLIENT(self->obj), style);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_set_priority(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "priority", NULL };
    int priority;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeClient.set_priority", kwlist, &priority))
        return NULL;
    gnome_client_set_priority(GNOME_CLIENT(self->obj), priority);
    Py_INCREF(Py_None);
    return Py_None;
}

#line 126 "ui.override"

typedef void (*clientfunc) (GnomeClient *, int, gchar*[]);
static PyObject*
generic_gnome_client_command (PyGObject *self, PyObject*args, PyObject* kwargs,
			      const char *name, clientfunc func)
{
    static char *kwlist[] = { "argc", "argv", NULL };
    char **argv, *fmt;
    int argc, size, i;
    PyObject *py_argv;

    fmt = g_strconcat("iO:Client.", name, NULL);
    if (!PyArg_ParseTupleAndKeywords(args, kwargs,
                                     fmt, kwlist, &argc, &py_argv)) {
	g_free(fmt);
	return NULL;
    }
    g_free(fmt);

    if (!PySequence_Check(py_argv)) {
	PyErr_SetString(PyExc_TypeError, "argv argument is not a sequence");
	return NULL;
    }

    size = PySequence_Length(py_argv);
    argv = g_new(gchar *, size + 1);
    for (i = 0; i < size; i++) {
	PyObject *item = PySequence_GetItem(py_argv, i);
	Py_DECREF(item);
	if (!PyString_Check(item)) {
	    PyErr_SetString(PyExc_TypeError, "argv element is not a string");
	    return NULL;
	}
	argv[i] = PyString_AsString(item);
    }
    argv[i] = NULL;
    func(GNOME_CLIENT(self->obj), argc, argv);
    g_free(argv);
    
    Py_INCREF(Py_None);
    return Py_None;
    
}

static PyObject*
_wrap_gnome_client_set_restart_command (PyGObject *self, PyObject *args,
					PyObject *kwargs)
{
    return generic_gnome_client_command(self, args, kwargs,
					"set_restart_command",
					gnome_client_set_restart_command);
}
#line 922 "ui.c"


#line 190 "ui.override"
static PyObject*
_wrap_gnome_client_set_discard_command (PyGObject *self, PyObject *args,
					PyObject *kwargs)
{
    return generic_gnome_client_command(self, args, kwargs,
					"set_discard_command",
					gnome_client_set_discard_command);
}
#line 934 "ui.c"


#line 200 "ui.override"
static PyObject*
_wrap_gnome_client_set_resign_command (PyGObject *self, PyObject *args,
				       PyObject *kwargs)
{
    return generic_gnome_client_command(self, args, kwargs,
					"set_resign_command",
					gnome_client_set_resign_command);
}
#line 946 "ui.c"


#line 210 "ui.override"
static PyObject*
_wrap_gnome_client_set_shutdown_command (PyGObject *self, PyObject *args,
					 PyObject *kwargs)
{
    return generic_gnome_client_command(self, args, kwargs,
					"set_shutdown_command",
					gnome_client_set_shutdown_command);
}
#line 958 "ui.c"


static PyObject *
_wrap_gnome_client_set_current_directory(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dir", NULL };
    char *dir;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeClient.set_current_directory", kwlist, &dir))
        return NULL;
    gnome_client_set_current_directory(GNOME_CLIENT(self->obj), dir);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_set_environment(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", "value", NULL };
    char *name, *value;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeClient.set_environment", kwlist, &name, &value))
        return NULL;
    gnome_client_set_environment(GNOME_CLIENT(self->obj), name, value);
    Py_INCREF(Py_None);
    return Py_None;
}

#line 180 "ui.override"
static PyObject*
_wrap_gnome_client_set_clone_command (PyGObject *self, PyObject *args,
				      PyObject *kwargs)
{
    return generic_gnome_client_command(self, args, kwargs,
					"set_clone_command",
					gnome_client_set_clone_command);
}
#line 996 "ui.c"


static PyObject *
_wrap_gnome_client_set_program(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "program", NULL };
    char *program;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeClient.set_program", kwlist, &program))
        return NULL;
    gnome_client_set_program(GNOME_CLIENT(self->obj), program);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_set_user_id(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "user_id", NULL };
    char *user_id;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeClient.set_user_id", kwlist, &user_id))
        return NULL;
    gnome_client_set_user_id(GNOME_CLIENT(self->obj), user_id);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_save_any_dialog(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dialog", NULL };
    PyGObject *dialog;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeClient.save_any_dialog", kwlist, &PyGtkDialog_Type, &dialog))
        return NULL;
    gnome_client_save_any_dialog(GNOME_CLIENT(self->obj), GTK_DIALOG(dialog->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_save_error_dialog(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dialog", NULL };
    PyGObject *dialog;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeClient.save_error_dialog", kwlist, &PyGtkDialog_Type, &dialog))
        return NULL;
    gnome_client_save_error_dialog(GNOME_CLIENT(self->obj), GTK_DIALOG(dialog->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_request_phase_2(PyGObject *self)
{
    gnome_client_request_phase_2(GNOME_CLIENT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_request_save(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "save_style", "shutdown", "interact_style", "fast", "global_", NULL };
    PyObject *py_save_style = NULL, *py_interact_style = NULL;
    int shutdown, fast, global;
    GnomeInteractStyle interact_style;
    GnomeSaveStyle save_style;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OiOii:GnomeClient.request_save", kwlist, &py_save_style, &shutdown, &py_interact_style, &fast, &global))
        return NULL;
    if (pyg_enum_get_value(GNOME_TYPE_SAVE_STYLE, py_save_style, (gint *)&save_style))
        return NULL;
    if (pyg_enum_get_value(GNOME_TYPE_INTERACT_STYLE, py_interact_style, (gint *)&interact_style))
        return NULL;
    gnome_client_request_save(GNOME_CLIENT(self->obj), save_style, shutdown, interact_style, fast, global);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_flush(PyGObject *self)
{
    gnome_client_flush(GNOME_CLIENT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_connect(PyGObject *self)
{
    gnome_client_connect(GNOME_CLIENT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_disconnect(PyGObject *self)
{
    gnome_client_disconnect(GNOME_CLIENT(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_set_id(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "client_id", NULL };
    char *client_id;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeClient.set_id", kwlist, &client_id))
        return NULL;
    gnome_client_set_id(GNOME_CLIENT(self->obj), client_id);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_get_id(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_client_get_id(GNOME_CLIENT(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_get_previous_id(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_client_get_previous_id(GNOME_CLIENT(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_get_desktop_id(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_client_get_desktop_id(GNOME_CLIENT(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeClient_methods[] = {
    { "get_config_prefix", (PyCFunction)_wrap_gnome_client_get_config_prefix, METH_NOARGS },
    { "get_global_config_prefix", (PyCFunction)_wrap_gnome_client_get_global_config_prefix, METH_NOARGS },
    { "set_global_config_prefix", (PyCFunction)_wrap_gnome_client_set_global_config_prefix, METH_VARARGS|METH_KEYWORDS },
    { "get_flags", (PyCFunction)_wrap_gnome_client_get_flags, METH_NOARGS },
    { "set_restart_style", (PyCFunction)_wrap_gnome_client_set_restart_style, METH_VARARGS|METH_KEYWORDS },
    { "set_priority", (PyCFunction)_wrap_gnome_client_set_priority, METH_VARARGS|METH_KEYWORDS },
    { "set_restart_command", (PyCFunction)_wrap_gnome_client_set_restart_command, METH_VARARGS|METH_KEYWORDS },
    { "set_discard_command", (PyCFunction)_wrap_gnome_client_set_discard_command, METH_VARARGS|METH_KEYWORDS },
    { "set_resign_command", (PyCFunction)_wrap_gnome_client_set_resign_command, METH_VARARGS|METH_KEYWORDS },
    { "set_shutdown_command", (PyCFunction)_wrap_gnome_client_set_shutdown_command, METH_VARARGS|METH_KEYWORDS },
    { "set_current_directory", (PyCFunction)_wrap_gnome_client_set_current_directory, METH_VARARGS|METH_KEYWORDS },
    { "set_environment", (PyCFunction)_wrap_gnome_client_set_environment, METH_VARARGS|METH_KEYWORDS },
    { "set_clone_command", (PyCFunction)_wrap_gnome_client_set_clone_command, METH_VARARGS|METH_KEYWORDS },
    { "set_program", (PyCFunction)_wrap_gnome_client_set_program, METH_VARARGS|METH_KEYWORDS },
    { "set_user_id", (PyCFunction)_wrap_gnome_client_set_user_id, METH_VARARGS|METH_KEYWORDS },
    { "save_any_dialog", (PyCFunction)_wrap_gnome_client_save_any_dialog, METH_VARARGS|METH_KEYWORDS },
    { "save_error_dialog", (PyCFunction)_wrap_gnome_client_save_error_dialog, METH_VARARGS|METH_KEYWORDS },
    { "request_phase_2", (PyCFunction)_wrap_gnome_client_request_phase_2, METH_NOARGS },
    { "request_save", (PyCFunction)_wrap_gnome_client_request_save, METH_VARARGS|METH_KEYWORDS },
    { "flush", (PyCFunction)_wrap_gnome_client_flush, METH_NOARGS },
    { "connect", (PyCFunction)_wrap_gnome_client_connect, METH_NOARGS },
    { "disconnect", (PyCFunction)_wrap_gnome_client_disconnect, METH_NOARGS },
    { "set_id", (PyCFunction)_wrap_gnome_client_set_id, METH_VARARGS|METH_KEYWORDS },
    { "get_id", (PyCFunction)_wrap_gnome_client_get_id, METH_NOARGS },
    { "get_previous_id", (PyCFunction)_wrap_gnome_client_get_previous_id, METH_NOARGS },
    { "get_desktop_id", (PyCFunction)_wrap_gnome_client_get_desktop_id, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeClient_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.Client",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeClient_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_client_new,		/* tp_init */
};



/* ----------- GnomeColorPicker ----------- */

static int
_wrap_gnome_color_picker_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomeColorPicker.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_color_picker_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeColorPicker object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_color_picker_set_d(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "r", "g", "b", "a", NULL };
    double r, g, b, a;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "dddd:GnomeColorPicker.set_d", kwlist, &r, &g, &b, &a))
        return NULL;
    gnome_color_picker_set_d(GNOME_COLOR_PICKER(self->obj), r, g, b, a);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_color_picker_set_i8(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "r", "g", "b", "a", NULL };
    int r, g, b, a;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iiii:GnomeColorPicker.set_i8", kwlist, &r, &g, &b, &a))
        return NULL;
    gnome_color_picker_set_i8(GNOME_COLOR_PICKER(self->obj), r, g, b, a);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_color_picker_set_i16(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "r", "g", "b", "a", NULL };
    int r, g, b, a;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iiii:GnomeColorPicker.set_i16", kwlist, &r, &g, &b, &a))
        return NULL;
    gnome_color_picker_set_i16(GNOME_COLOR_PICKER(self->obj), r, g, b, a);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_color_picker_set_dither(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dither", NULL };
    int dither;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeColorPicker.set_dither", kwlist, &dither))
        return NULL;
    gnome_color_picker_set_dither(GNOME_COLOR_PICKER(self->obj), dither);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_color_picker_get_dither(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_color_picker_get_dither(GNOME_COLOR_PICKER(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_color_picker_set_use_alpha(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "use_alpha", NULL };
    int use_alpha;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeColorPicker.set_use_alpha", kwlist, &use_alpha))
        return NULL;
    gnome_color_picker_set_use_alpha(GNOME_COLOR_PICKER(self->obj), use_alpha);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_color_picker_get_use_alpha(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_color_picker_get_use_alpha(GNOME_COLOR_PICKER(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_color_picker_set_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "title", NULL };
    char *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeColorPicker.set_title", kwlist, &title))
        return NULL;
    gnome_color_picker_set_title(GNOME_COLOR_PICKER(self->obj), title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_color_picker_get_title(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_color_picker_get_title(GNOME_COLOR_PICKER(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeColorPicker_methods[] = {
    { "set_d", (PyCFunction)_wrap_gnome_color_picker_set_d, METH_VARARGS|METH_KEYWORDS },
    { "set_i8", (PyCFunction)_wrap_gnome_color_picker_set_i8, METH_VARARGS|METH_KEYWORDS },
    { "set_i16", (PyCFunction)_wrap_gnome_color_picker_set_i16, METH_VARARGS|METH_KEYWORDS },
    { "set_dither", (PyCFunction)_wrap_gnome_color_picker_set_dither, METH_VARARGS|METH_KEYWORDS },
    { "get_dither", (PyCFunction)_wrap_gnome_color_picker_get_dither, METH_NOARGS },
    { "set_use_alpha", (PyCFunction)_wrap_gnome_color_picker_set_use_alpha, METH_VARARGS|METH_KEYWORDS },
    { "get_use_alpha", (PyCFunction)_wrap_gnome_color_picker_get_use_alpha, METH_NOARGS },
    { "set_title", (PyCFunction)_wrap_gnome_color_picker_set_title, METH_VARARGS|METH_KEYWORDS },
    { "get_title", (PyCFunction)_wrap_gnome_color_picker_get_title, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeColorPicker_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.ColorPicker",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeColorPicker_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_color_picker_new,		/* tp_init */
};



/* ----------- GnomeDateEdit ----------- */

static int
_wrap_gnome_date_edit_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "the_time", "show_time", "use_24_format", NULL };
    time_t the_time;
    int show_time, use_24_format;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iii:GnomeDateEdit.__init__", kwlist, &the_time, &show_time, &use_24_format))
        return -1;
    self->obj = (GObject *)gnome_date_edit_new(the_time, show_time, use_24_format);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeDateEdit object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_date_edit_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "the_time", "flags", NULL };
    time_t the_time;
    PyObject *py_flags = NULL;
    GnomeDateEditFlags flags;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iO:GnomeDateEdit.construct", kwlist, &the_time, &py_flags))
        return NULL;
    if (pyg_flags_get_value(GNOME_TYPE_DATE_EDIT_FLAGS, py_flags, (gint *)&flags))
        return NULL;
    gnome_date_edit_construct(GNOME_DATE_EDIT(self->obj), the_time, flags);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_date_edit_set_time(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "the_time", NULL };
    time_t the_time;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeDateEdit.set_time", kwlist, &the_time))
        return NULL;
    gnome_date_edit_set_time(GNOME_DATE_EDIT(self->obj), the_time);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_date_edit_get_time(PyGObject *self)
{
    time_t ret;

    ret = gnome_date_edit_get_time(GNOME_DATE_EDIT(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_date_edit_set_popup_range(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "low_hour", "up_hour", NULL };
    int low_hour, up_hour;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:GnomeDateEdit.set_popup_range", kwlist, &low_hour, &up_hour))
        return NULL;
    gnome_date_edit_set_popup_range(GNOME_DATE_EDIT(self->obj), low_hour, up_hour);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_date_edit_set_flags(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "flags", NULL };
    PyObject *py_flags = NULL;
    GnomeDateEditFlags flags;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDateEdit.set_flags", kwlist, &py_flags))
        return NULL;
    if (pyg_flags_get_value(GNOME_TYPE_DATE_EDIT_FLAGS, py_flags, (gint *)&flags))
        return NULL;
    gnome_date_edit_set_flags(GNOME_DATE_EDIT(self->obj), flags);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_date_edit_get_flags(PyGObject *self)
{
    int ret;

    ret = gnome_date_edit_get_flags(GNOME_DATE_EDIT(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_date_edit_get_initial_time(PyGObject *self)
{
    time_t ret;

    ret = gnome_date_edit_get_initial_time(GNOME_DATE_EDIT(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_date_edit_get_date(PyGObject *self)
{
    time_t ret;

    ret = gnome_date_edit_get_date(GNOME_DATE_EDIT(self->obj));
    return PyInt_FromLong(ret);
}

static PyMethodDef _PyGnomeDateEdit_methods[] = {
    { "construct", (PyCFunction)_wrap_gnome_date_edit_construct, METH_VARARGS|METH_KEYWORDS },
    { "set_time", (PyCFunction)_wrap_gnome_date_edit_set_time, METH_VARARGS|METH_KEYWORDS },
    { "get_time", (PyCFunction)_wrap_gnome_date_edit_get_time, METH_NOARGS },
    { "set_popup_range", (PyCFunction)_wrap_gnome_date_edit_set_popup_range, METH_VARARGS|METH_KEYWORDS },
    { "set_flags", (PyCFunction)_wrap_gnome_date_edit_set_flags, METH_VARARGS|METH_KEYWORDS },
    { "get_flags", (PyCFunction)_wrap_gnome_date_edit_get_flags, METH_NOARGS },
    { "get_initial_time", (PyCFunction)_wrap_gnome_date_edit_get_initial_time, METH_NOARGS },
    { "get_date", (PyCFunction)_wrap_gnome_date_edit_get_date, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeDateEdit_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.DateEdit",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeDateEdit_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_date_edit_new,		/* tp_init */
};



/* ----------- GnomeDialog ----------- */

static int
pygobject_no_constructor(PyObject *self, PyObject *args, PyObject *kwargs)
{
    gchar buf[512];

    g_snprintf(buf, sizeof(buf), "%s is an abstract widget", self->ob_type->tp_name);
    PyErr_SetString(PyExc_NotImplementedError, buf);
    return -1;
}

static PyObject *
_wrap_gnome_dialog_set_parent(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "parent", NULL };
    PyGObject *parent;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDialog.set_parent", kwlist, &PyGtkWindow_Type, &parent))
        return NULL;
    gnome_dialog_set_parent(GNOME_DIALOG(self->obj), GTK_WINDOW(parent->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_run(PyGObject *self)
{
    int ret;

    ret = gnome_dialog_run(GNOME_DIALOG(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_dialog_run_and_close(PyGObject *self)
{
    int ret;

    ret = gnome_dialog_run_and_close(GNOME_DIALOG(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_dialog_set_default(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "button", NULL };
    int button;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeDialog.set_default", kwlist, &button))
        return NULL;
    gnome_dialog_set_default(GNOME_DIALOG(self->obj), button);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_grab_focus(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "button", NULL };
    int button;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeDialog.grab_focus", kwlist, &button))
        return NULL;
    gnome_dialog_grab_focus(GNOME_DIALOG(self->obj), button);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_set_sensitive(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "button", "setting", NULL };
    int button, setting;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:GnomeDialog.set_sensitive", kwlist, &button, &setting))
        return NULL;
    gnome_dialog_set_sensitive(GNOME_DIALOG(self->obj), button, setting);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_close(PyGObject *self)
{
    gnome_dialog_close(GNOME_DIALOG(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_close_hides(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "just_hide", NULL };
    int just_hide;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeDialog.close_hides", kwlist, &just_hide))
        return NULL;
    gnome_dialog_close_hides(GNOME_DIALOG(self->obj), just_hide);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_set_close(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "click_closes", NULL };
    int click_closes;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeDialog.set_close", kwlist, &click_closes))
        return NULL;
    gnome_dialog_set_close(GNOME_DIALOG(self->obj), click_closes);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_editable_enters(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "editable", NULL };
    PyGObject *editable;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDialog.editable_enters", kwlist, &PyGtkEditable_Type, &editable))
        return NULL;
    gnome_dialog_editable_enters(GNOME_DIALOG(self->obj), GTK_EDITABLE(editable->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_append_button(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeDialog.append_button", kwlist, &name))
        return NULL;
    gnome_dialog_append_button(GNOME_DIALOG(self->obj), name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_dialog_append_button_with_pixmap(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", "pixmap", NULL };
    char *name, *pixmap;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeDialog.append_button_with_pixmap", kwlist, &name, &pixmap))
        return NULL;
    gnome_dialog_append_button_with_pixmap(GNOME_DIALOG(self->obj), name, pixmap);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeDialog_methods[] = {
    { "set_parent", (PyCFunction)_wrap_gnome_dialog_set_parent, METH_VARARGS|METH_KEYWORDS },
    { "run", (PyCFunction)_wrap_gnome_dialog_run, METH_NOARGS },
    { "run_and_close", (PyCFunction)_wrap_gnome_dialog_run_and_close, METH_NOARGS },
    { "set_default", (PyCFunction)_wrap_gnome_dialog_set_default, METH_VARARGS|METH_KEYWORDS },
    { "grab_focus", (PyCFunction)_wrap_gnome_dialog_grab_focus, METH_VARARGS|METH_KEYWORDS },
    { "set_sensitive", (PyCFunction)_wrap_gnome_dialog_set_sensitive, METH_VARARGS|METH_KEYWORDS },
    { "close", (PyCFunction)_wrap_gnome_dialog_close, METH_NOARGS },
    { "close_hides", (PyCFunction)_wrap_gnome_dialog_close_hides, METH_VARARGS|METH_KEYWORDS },
    { "set_close", (PyCFunction)_wrap_gnome_dialog_set_close, METH_VARARGS|METH_KEYWORDS },
    { "editable_enters", (PyCFunction)_wrap_gnome_dialog_editable_enters, METH_VARARGS|METH_KEYWORDS },
    { "append_button", (PyCFunction)_wrap_gnome_dialog_append_button, METH_VARARGS|METH_KEYWORDS },
    { "append_button_with_pixmap", (PyCFunction)_wrap_gnome_dialog_append_button_with_pixmap, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeDialog_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.Dialog",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeDialog_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- GnomeDruid ----------- */

static int
_wrap_gnome_druid_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomeDruid.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_druid_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeDruid object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_druid_set_buttons_sensitive(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "back_sensitive", "next_sensitive", "cancel_sensitive", "help_sensitive", NULL };
    int back_sensitive, next_sensitive, cancel_sensitive, help_sensitive;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iiii:GnomeDruid.set_buttons_sensitive", kwlist, &back_sensitive, &next_sensitive, &cancel_sensitive, &help_sensitive))
        return NULL;
    gnome_druid_set_buttons_sensitive(GNOME_DRUID(self->obj), back_sensitive, next_sensitive, cancel_sensitive, help_sensitive);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_set_show_finish(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "show_finish", NULL };
    int show_finish;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeDruid.set_show_finish", kwlist, &show_finish))
        return NULL;
    gnome_druid_set_show_finish(GNOME_DRUID(self->obj), show_finish);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_set_show_help(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "show_help", NULL };
    int show_help;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeDruid.set_show_help", kwlist, &show_help))
        return NULL;
    gnome_druid_set_show_help(GNOME_DRUID(self->obj), show_help);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_prepend_page(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "page", NULL };
    PyGObject *page;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruid.prepend_page", kwlist, &PyGnomeDruidPage_Type, &page))
        return NULL;
    gnome_druid_prepend_page(GNOME_DRUID(self->obj), GNOME_DRUID_PAGE(page->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_insert_page(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "back_page", "page", NULL };
    PyGObject *back_page, *page;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O!:GnomeDruid.insert_page", kwlist, &PyGnomeDruidPage_Type, &back_page, &PyGnomeDruidPage_Type, &page))
        return NULL;
    gnome_druid_insert_page(GNOME_DRUID(self->obj), GNOME_DRUID_PAGE(back_page->obj), GNOME_DRUID_PAGE(page->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_append_page(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "page", NULL };
    PyGObject *page;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruid.append_page", kwlist, &PyGnomeDruidPage_Type, &page))
        return NULL;
    gnome_druid_append_page(GNOME_DRUID(self->obj), GNOME_DRUID_PAGE(page->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_set_page(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "page", NULL };
    PyGObject *page;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruid.set_page", kwlist, &PyGnomeDruidPage_Type, &page))
        return NULL;
    gnome_druid_set_page(GNOME_DRUID(self->obj), GNOME_DRUID_PAGE(page->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeDruid_methods[] = {
    { "set_buttons_sensitive", (PyCFunction)_wrap_gnome_druid_set_buttons_sensitive, METH_VARARGS|METH_KEYWORDS },
    { "set_show_finish", (PyCFunction)_wrap_gnome_druid_set_show_finish, METH_VARARGS|METH_KEYWORDS },
    { "set_show_help", (PyCFunction)_wrap_gnome_druid_set_show_help, METH_VARARGS|METH_KEYWORDS },
    { "prepend_page", (PyCFunction)_wrap_gnome_druid_prepend_page, METH_VARARGS|METH_KEYWORDS },
    { "insert_page", (PyCFunction)_wrap_gnome_druid_insert_page, METH_VARARGS|METH_KEYWORDS },
    { "append_page", (PyCFunction)_wrap_gnome_druid_append_page, METH_VARARGS|METH_KEYWORDS },
    { "set_page", (PyCFunction)_wrap_gnome_druid_set_page, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

static PyObject *
_wrap_gnome_druid__get_help(PyObject *self, void *closure)
{
    GtkWidget *ret;

    ret = GNOME_DRUID(pygobject_get(self))->help;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid__get_back(PyObject *self, void *closure)
{
    GtkWidget *ret;

    ret = GNOME_DRUID(pygobject_get(self))->back;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid__get_next(PyObject *self, void *closure)
{
    GtkWidget *ret;

    ret = GNOME_DRUID(pygobject_get(self))->next;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid__get_cancel(PyObject *self, void *closure)
{
    GtkWidget *ret;

    ret = GNOME_DRUID(pygobject_get(self))->cancel;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid__get_finish(PyObject *self, void *closure)
{
    GtkWidget *ret;

    ret = GNOME_DRUID(pygobject_get(self))->finish;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyGetSetDef gnome_druid_getsets[] = {
    { "help", (getter)_wrap_gnome_druid__get_help, (setter)0 },
    { "back", (getter)_wrap_gnome_druid__get_back, (setter)0 },
    { "next", (getter)_wrap_gnome_druid__get_next, (setter)0 },
    { "cancel", (getter)_wrap_gnome_druid__get_cancel, (setter)0 },
    { "finish", (getter)_wrap_gnome_druid__get_finish, (setter)0 },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject PyGnomeDruid_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.Druid",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeDruid_methods,			/* tp_methods */
    0,					/* tp_members */
    gnome_druid_getsets,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_druid_new,		/* tp_init */
};



/* ----------- GnomeDruidPage ----------- */

static int
_wrap_gnome_druid_page_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomeDruidPage.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_druid_page_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeDruidPage object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_druid_page_next(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_druid_page_next(GNOME_DRUID_PAGE(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_druid_page_prepare(PyGObject *self)
{
    gnome_druid_page_prepare(GNOME_DRUID_PAGE(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_back(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_druid_page_back(GNOME_DRUID_PAGE(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_druid_page_cancel(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_druid_page_cancel(GNOME_DRUID_PAGE(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_druid_page_finish(PyGObject *self)
{
    gnome_druid_page_finish(GNOME_DRUID_PAGE(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeDruidPage_methods[] = {
    { "next", (PyCFunction)_wrap_gnome_druid_page_next, METH_NOARGS },
    { "prepare", (PyCFunction)_wrap_gnome_druid_page_prepare, METH_NOARGS },
    { "back", (PyCFunction)_wrap_gnome_druid_page_back, METH_NOARGS },
    { "cancel", (PyCFunction)_wrap_gnome_druid_page_cancel, METH_NOARGS },
    { "finish", (PyCFunction)_wrap_gnome_druid_page_finish, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeDruidPage_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.DruidPage",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeDruidPage_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_druid_page_new,		/* tp_init */
};



/* ----------- GnomeDruidPageEdge ----------- */

static int
_wrap_gnome_druid_page_edge_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "position", NULL };
    PyObject *py_position = NULL;
    GnomeEdgePosition position;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageEdge.__init__", kwlist, &py_position))
        return -1;
    if (pyg_enum_get_value(GNOME_TYPE_EDGE_POSITION, py_position, (gint *)&position))
        return -1;
    self->obj = (GObject *)gnome_druid_page_edge_new(position);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeDruidPageEdge object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_druid_page_edge_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "position", "antialiaed", "title", "text", "logo", "watermark", "top_watermark", NULL };
    PyObject *py_position = NULL;
    int antialiaed;
    char *title, *text;
    PyGObject *logo, *watermark, *top_watermark;
    GnomeEdgePosition position;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OissO!O!O!:GnomeDruidPageEdge.construct", kwlist, &py_position, &antialiaed, &title, &text, &PyGdkPixbuf_Type, &logo, &PyGdkPixbuf_Type, &watermark, &PyGdkPixbuf_Type, &top_watermark))
        return NULL;
    if (pyg_enum_get_value(GNOME_TYPE_EDGE_POSITION, py_position, (gint *)&position))
        return NULL;
    gnome_druid_page_edge_construct(GNOME_DRUID_PAGE_EDGE(self->obj), position, antialiaed, title, text, GDK_PIXBUF(logo->obj), GDK_PIXBUF(watermark->obj), GDK_PIXBUF(top_watermark->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_bg_color(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageEdge.set_bg_color", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_edge_set_bg_color(GNOME_DRUID_PAGE_EDGE(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_textbox_color(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageEdge.set_textbox_color", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_edge_set_textbox_color(GNOME_DRUID_PAGE_EDGE(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_logo_bg_color(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageEdge.set_logo_bg_color", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_edge_set_logo_bg_color(GNOME_DRUID_PAGE_EDGE(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_title_color(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageEdge.set_title_color", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_edge_set_title_color(GNOME_DRUID_PAGE_EDGE(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_text_color(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageEdge.set_text_color", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_edge_set_text_color(GNOME_DRUID_PAGE_EDGE(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_text(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "text", NULL };
    char *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeDruidPageEdge.set_text", kwlist, &text))
        return NULL;
    gnome_druid_page_edge_set_text(GNOME_DRUID_PAGE_EDGE(self->obj), text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "title", NULL };
    char *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeDruidPageEdge.set_title", kwlist, &title))
        return NULL;
    gnome_druid_page_edge_set_title(GNOME_DRUID_PAGE_EDGE(self->obj), title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_logo(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "logo_image", NULL };
    PyGObject *logo_image;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruidPageEdge.set_logo", kwlist, &PyGdkPixbuf_Type, &logo_image))
        return NULL;
    gnome_druid_page_edge_set_logo(GNOME_DRUID_PAGE_EDGE(self->obj), GDK_PIXBUF(logo_image->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_watermark(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "watermark", NULL };
    PyGObject *watermark;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruidPageEdge.set_watermark", kwlist, &PyGdkPixbuf_Type, &watermark))
        return NULL;
    gnome_druid_page_edge_set_watermark(GNOME_DRUID_PAGE_EDGE(self->obj), GDK_PIXBUF(watermark->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_edge_set_top_watermark(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "top_watermark", NULL };
    PyGObject *top_watermark;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruidPageEdge.set_top_watermark", kwlist, &PyGdkPixbuf_Type, &top_watermark))
        return NULL;
    gnome_druid_page_edge_set_top_watermark(GNOME_DRUID_PAGE_EDGE(self->obj), GDK_PIXBUF(top_watermark->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeDruidPageEdge_methods[] = {
    { "construct", (PyCFunction)_wrap_gnome_druid_page_edge_construct, METH_VARARGS|METH_KEYWORDS },
    { "set_bg_color", (PyCFunction)_wrap_gnome_druid_page_edge_set_bg_color, METH_VARARGS|METH_KEYWORDS },
    { "set_textbox_color", (PyCFunction)_wrap_gnome_druid_page_edge_set_textbox_color, METH_VARARGS|METH_KEYWORDS },
    { "set_logo_bg_color", (PyCFunction)_wrap_gnome_druid_page_edge_set_logo_bg_color, METH_VARARGS|METH_KEYWORDS },
    { "set_title_color", (PyCFunction)_wrap_gnome_druid_page_edge_set_title_color, METH_VARARGS|METH_KEYWORDS },
    { "set_text_color", (PyCFunction)_wrap_gnome_druid_page_edge_set_text_color, METH_VARARGS|METH_KEYWORDS },
    { "set_text", (PyCFunction)_wrap_gnome_druid_page_edge_set_text, METH_VARARGS|METH_KEYWORDS },
    { "set_title", (PyCFunction)_wrap_gnome_druid_page_edge_set_title, METH_VARARGS|METH_KEYWORDS },
    { "set_logo", (PyCFunction)_wrap_gnome_druid_page_edge_set_logo, METH_VARARGS|METH_KEYWORDS },
    { "set_watermark", (PyCFunction)_wrap_gnome_druid_page_edge_set_watermark, METH_VARARGS|METH_KEYWORDS },
    { "set_top_watermark", (PyCFunction)_wrap_gnome_druid_page_edge_set_top_watermark, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeDruidPageEdge_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.DruidPageEdge",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeDruidPageEdge_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_druid_page_edge_new,		/* tp_init */
};



/* ----------- GnomeDruidPageStandard ----------- */

static int
_wrap_gnome_druid_page_standard_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomeDruidPageStandard.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_druid_page_standard_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeDruidPageStandard object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_druid_page_standard_set_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "title", NULL };
    char *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeDruidPageStandard.set_title", kwlist, &title))
        return NULL;
    gnome_druid_page_standard_set_title(GNOME_DRUID_PAGE_STANDARD(self->obj), title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard_set_logo(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "logo_image", NULL };
    PyGObject *logo_image;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruidPageStandard.set_logo", kwlist, &PyGdkPixbuf_Type, &logo_image))
        return NULL;
    gnome_druid_page_standard_set_logo(GNOME_DRUID_PAGE_STANDARD(self->obj), GDK_PIXBUF(logo_image->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard_set_top_watermark(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "top_watermark_image", NULL };
    PyGObject *top_watermark_image;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeDruidPageStandard.set_top_watermark", kwlist, &PyGdkPixbuf_Type, &top_watermark_image))
        return NULL;
    gnome_druid_page_standard_set_top_watermark(GNOME_DRUID_PAGE_STANDARD(self->obj), GDK_PIXBUF(top_watermark_image->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard_set_title_foreground(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageStandard.set_title_foreground", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_standard_set_title_foreground(GNOME_DRUID_PAGE_STANDARD(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard_set_background(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageStandard.set_background", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_standard_set_background(GNOME_DRUID_PAGE_STANDARD(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard_set_logo_background(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageStandard.set_logo_background", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_standard_set_logo_background(GNOME_DRUID_PAGE_STANDARD(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard_set_contents_background(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "color", NULL };
    PyObject *py_color;
    GdkColor *color = NULL;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeDruidPageStandard.set_contents_background", kwlist, &py_color))
        return NULL;
    if (pyg_boxed_check(py_color, GDK_TYPE_COLOR))
        color = pyg_boxed_get(py_color, GdkColor);
    else {
        PyErr_SetString(PyExc_TypeError, "color should be a GdkColor");
        return NULL;
    }
    gnome_druid_page_standard_set_contents_background(GNOME_DRUID_PAGE_STANDARD(self->obj), color);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard_append_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "question_mnemonic", "item", "additional_info_markup", NULL };
    char *question_mnemonic, *additional_info_markup;
    PyGObject *item;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!s:GnomeDruidPageStandard.append_item", kwlist, &question_mnemonic, &PyGtkWidget_Type, &item, &additional_info_markup))
        return NULL;
    gnome_druid_page_standard_append_item(GNOME_DRUID_PAGE_STANDARD(self->obj), question_mnemonic, GTK_WIDGET(item->obj), additional_info_markup);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeDruidPageStandard_methods[] = {
    { "set_title", (PyCFunction)_wrap_gnome_druid_page_standard_set_title, METH_VARARGS|METH_KEYWORDS },
    { "set_logo", (PyCFunction)_wrap_gnome_druid_page_standard_set_logo, METH_VARARGS|METH_KEYWORDS },
    { "set_top_watermark", (PyCFunction)_wrap_gnome_druid_page_standard_set_top_watermark, METH_VARARGS|METH_KEYWORDS },
    { "set_title_foreground", (PyCFunction)_wrap_gnome_druid_page_standard_set_title_foreground, METH_VARARGS|METH_KEYWORDS },
    { "set_background", (PyCFunction)_wrap_gnome_druid_page_standard_set_background, METH_VARARGS|METH_KEYWORDS },
    { "set_logo_background", (PyCFunction)_wrap_gnome_druid_page_standard_set_logo_background, METH_VARARGS|METH_KEYWORDS },
    { "set_contents_background", (PyCFunction)_wrap_gnome_druid_page_standard_set_contents_background, METH_VARARGS|METH_KEYWORDS },
    { "append_item", (PyCFunction)_wrap_gnome_druid_page_standard_append_item, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

static PyObject *
_wrap_gnome_druid_page_standard__get_vbox(PyObject *self, void *closure)
{
    GtkWidget *ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->vbox;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid_page_standard__get_title(PyObject *self, void *closure)
{
    const gchar *ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->title;
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_druid_page_standard__get_logo(PyObject *self, void *closure)
{
    GdkPixbuf *ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->logo;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid_page_standard__get_top_watermark(PyObject *self, void *closure)
{
    GdkPixbuf *ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->top_watermark;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid_page_standard__get_title_foreground(PyObject *self, void *closure)
{
    GdkColor ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->title_foreground;
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GDK_TYPE_COLOR, &ret, TRUE, TRUE);
}

static PyObject *
_wrap_gnome_druid_page_standard__get_background(PyObject *self, void *closure)
{
    GdkColor ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->background;
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GDK_TYPE_COLOR, &ret, TRUE, TRUE);
}

static PyObject *
_wrap_gnome_druid_page_standard__get_logo_background(PyObject *self, void *closure)
{
    GdkColor ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->logo_background;
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GDK_TYPE_COLOR, &ret, TRUE, TRUE);
}

static PyObject *
_wrap_gnome_druid_page_standard__get_contents_background(PyObject *self, void *closure)
{
    GdkColor ret;

    ret = GNOME_DRUID_PAGE_STANDARD(pygobject_get(self))->contents_background;
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GDK_TYPE_COLOR, &ret, TRUE, TRUE);
}

static PyGetSetDef gnome_druid_page_standard_getsets[] = {
    { "vbox", (getter)_wrap_gnome_druid_page_standard__get_vbox, (setter)0 },
    { "title", (getter)_wrap_gnome_druid_page_standard__get_title, (setter)0 },
    { "logo", (getter)_wrap_gnome_druid_page_standard__get_logo, (setter)0 },
    { "top_watermark", (getter)_wrap_gnome_druid_page_standard__get_top_watermark, (setter)0 },
    { "title_foreground", (getter)_wrap_gnome_druid_page_standard__get_title_foreground, (setter)0 },
    { "background", (getter)_wrap_gnome_druid_page_standard__get_background, (setter)0 },
    { "logo_background", (getter)_wrap_gnome_druid_page_standard__get_logo_background, (setter)0 },
    { "contents_background", (getter)_wrap_gnome_druid_page_standard__get_contents_background, (setter)0 },
    { NULL, (getter)0, (setter)0 },
};

PyTypeObject PyGnomeDruidPageStandard_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.DruidPageStandard",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeDruidPageStandard_methods,			/* tp_methods */
    0,					/* tp_members */
    gnome_druid_page_standard_getsets,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_druid_page_standard_new,		/* tp_init */
};



/* ----------- GnomeEntry ----------- */

static int
_wrap_gnome_entry_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", NULL };
    char *history_id;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeEntry.__init__", kwlist, &history_id))
        return -1;
    self->obj = (GObject *)gnome_entry_new(history_id);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeEntry object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_entry_gtk_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_entry_gtk_entry(GNOME_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_entry_get_history_id(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_entry_get_history_id(GNOME_ENTRY(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_entry_set_history_id(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", NULL };
    char *history_id;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeEntry.set_history_id", kwlist, &history_id))
        return NULL;
    gnome_entry_set_history_id(GNOME_ENTRY(self->obj), history_id);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_entry_set_max_saved(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "max_saved", NULL };
    int max_saved;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeEntry.set_max_saved", kwlist, &max_saved))
        return NULL;
    gnome_entry_set_max_saved(GNOME_ENTRY(self->obj), max_saved);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_entry_get_max_saved(PyGObject *self)
{
    int ret;

    ret = gnome_entry_get_max_saved(GNOME_ENTRY(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_entry_prepend_history(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "save", "text", NULL };
    int save;
    char *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "is:GnomeEntry.prepend_history", kwlist, &save, &text))
        return NULL;
    gnome_entry_prepend_history(GNOME_ENTRY(self->obj), save, text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_entry_append_history(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "save", "text", NULL };
    int save;
    char *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "is:GnomeEntry.append_history", kwlist, &save, &text))
        return NULL;
    gnome_entry_append_history(GNOME_ENTRY(self->obj), save, text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_entry_clear_history(PyGObject *self)
{
    gnome_entry_clear_history(GNOME_ENTRY(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeEntry_methods[] = {
    { "gtk_entry", (PyCFunction)_wrap_gnome_entry_gtk_entry, METH_NOARGS },
    { "get_history_id", (PyCFunction)_wrap_gnome_entry_get_history_id, METH_NOARGS },
    { "set_history_id", (PyCFunction)_wrap_gnome_entry_set_history_id, METH_VARARGS|METH_KEYWORDS },
    { "set_max_saved", (PyCFunction)_wrap_gnome_entry_set_max_saved, METH_VARARGS|METH_KEYWORDS },
    { "get_max_saved", (PyCFunction)_wrap_gnome_entry_get_max_saved, METH_NOARGS },
    { "prepend_history", (PyCFunction)_wrap_gnome_entry_prepend_history, METH_VARARGS|METH_KEYWORDS },
    { "append_history", (PyCFunction)_wrap_gnome_entry_append_history, METH_VARARGS|METH_KEYWORDS },
    { "clear_history", (PyCFunction)_wrap_gnome_entry_clear_history, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeEntry_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.Entry",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeEntry_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_entry_new,		/* tp_init */
};



/* ----------- GnomeFileEntry ----------- */

static int
_wrap_gnome_file_entry_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", "browse_dialog_title", NULL };
    char *history_id, *browse_dialog_title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeFileEntry.__init__", kwlist, &history_id, &browse_dialog_title))
        return -1;
    self->obj = (GObject *)gnome_file_entry_new(history_id, browse_dialog_title);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeFileEntry object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_file_entry_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", "browse_dialog_title", NULL };
    char *history_id, *browse_dialog_title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeFileEntry.construct", kwlist, &history_id, &browse_dialog_title))
        return NULL;
    gnome_file_entry_construct(GNOME_FILE_ENTRY(self->obj), history_id, browse_dialog_title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_file_entry_gnome_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_file_entry_gnome_entry(GNOME_FILE_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_file_entry_gtk_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_file_entry_gtk_entry(GNOME_FILE_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_file_entry_set_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "browse_dialog_title", NULL };
    char *browse_dialog_title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeFileEntry.set_title", kwlist, &browse_dialog_title))
        return NULL;
    gnome_file_entry_set_title(GNOME_FILE_ENTRY(self->obj), browse_dialog_title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_file_entry_set_default_path(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeFileEntry.set_default_path", kwlist, &path))
        return NULL;
    gnome_file_entry_set_default_path(GNOME_FILE_ENTRY(self->obj), path);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_file_entry_set_directory_entry(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "directory_entry", NULL };
    int directory_entry;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeFileEntry.set_directory_entry", kwlist, &directory_entry))
        return NULL;
    gnome_file_entry_set_directory_entry(GNOME_FILE_ENTRY(self->obj), directory_entry);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_file_entry_get_directory_entry(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_file_entry_get_directory_entry(GNOME_FILE_ENTRY(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_file_entry_get_full_path(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "file_must_exist", NULL };
    int file_must_exist;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeFileEntry.get_full_path", kwlist, &file_must_exist))
        return NULL;
    ret = gnome_file_entry_get_full_path(GNOME_FILE_ENTRY(self->obj), file_must_exist);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_file_entry_set_filename(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeFileEntry.set_filename", kwlist, &filename))
        return NULL;
    gnome_file_entry_set_filename(GNOME_FILE_ENTRY(self->obj), filename);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_file_entry_set_modal(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "is_modal", NULL };
    int is_modal;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeFileEntry.set_modal", kwlist, &is_modal))
        return NULL;
    gnome_file_entry_set_modal(GNOME_FILE_ENTRY(self->obj), is_modal);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_file_entry_get_modal(PyGObject *self)
{
    int ret;
    PyObject *py_ret;

    ret = gnome_file_entry_get_modal(GNOME_FILE_ENTRY(self->obj));
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_file_entry_set_directory(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "directory_entry", NULL };
    int directory_entry;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeFileEntry.set_directory", kwlist, &directory_entry))
        return NULL;
    gnome_file_entry_set_directory(GNOME_FILE_ENTRY(self->obj), directory_entry);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeFileEntry_methods[] = {
    { "construct", (PyCFunction)_wrap_gnome_file_entry_construct, METH_VARARGS|METH_KEYWORDS },
    { "gnome_entry", (PyCFunction)_wrap_gnome_file_entry_gnome_entry, METH_NOARGS },
    { "gtk_entry", (PyCFunction)_wrap_gnome_file_entry_gtk_entry, METH_NOARGS },
    { "set_title", (PyCFunction)_wrap_gnome_file_entry_set_title, METH_VARARGS|METH_KEYWORDS },
    { "set_default_path", (PyCFunction)_wrap_gnome_file_entry_set_default_path, METH_VARARGS|METH_KEYWORDS },
    { "set_directory_entry", (PyCFunction)_wrap_gnome_file_entry_set_directory_entry, METH_VARARGS|METH_KEYWORDS },
    { "get_directory_entry", (PyCFunction)_wrap_gnome_file_entry_get_directory_entry, METH_NOARGS },
    { "get_full_path", (PyCFunction)_wrap_gnome_file_entry_get_full_path, METH_VARARGS|METH_KEYWORDS },
    { "set_filename", (PyCFunction)_wrap_gnome_file_entry_set_filename, METH_VARARGS|METH_KEYWORDS },
    { "set_modal", (PyCFunction)_wrap_gnome_file_entry_set_modal, METH_VARARGS|METH_KEYWORDS },
    { "get_modal", (PyCFunction)_wrap_gnome_file_entry_get_modal, METH_NOARGS },
    { "set_directory", (PyCFunction)_wrap_gnome_file_entry_set_directory, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeFileEntry_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.FileEntry",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeFileEntry_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_file_entry_new,		/* tp_init */
};



/* ----------- GnomeFontPicker ----------- */

static int
_wrap_gnome_font_picker_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomeFontPicker.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_font_picker_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeFontPicker object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_font_picker_set_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "title", NULL };
    char *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeFontPicker.set_title", kwlist, &title))
        return NULL;
    gnome_font_picker_set_title(GNOME_FONT_PICKER(self->obj), title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_get_title(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_font_picker_get_title(GNOME_FONT_PICKER(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_get_mode(PyGObject *self)
{
    gint ret;

    ret = gnome_font_picker_get_mode(GNOME_FONT_PICKER(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_font_picker_set_mode(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "mode", NULL };
    PyObject *py_mode = NULL;
    GnomeFontPickerMode mode;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeFontPicker.set_mode", kwlist, &py_mode))
        return NULL;
    if (pyg_enum_get_value(GNOME_TYPE_FONT_PICKER_MODE, py_mode, (gint *)&mode))
        return NULL;
    gnome_font_picker_set_mode(GNOME_FONT_PICKER(self->obj), mode);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_fi_set_use_font_in_label(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "use_font_in_label", "size", NULL };
    int use_font_in_label, size;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:GnomeFontPicker.fi_set_use_font_in_label", kwlist, &use_font_in_label, &size))
        return NULL;
    gnome_font_picker_fi_set_use_font_in_label(GNOME_FONT_PICKER(self->obj), use_font_in_label, size);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_fi_set_show_size(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "show_size", NULL };
    int show_size;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeFontPicker.fi_set_show_size", kwlist, &show_size))
        return NULL;
    gnome_font_picker_fi_set_show_size(GNOME_FONT_PICKER(self->obj), show_size);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_uw_set_widget(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "widget", NULL };
    PyGObject *widget;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeFontPicker.uw_set_widget", kwlist, &PyGtkWidget_Type, &widget))
        return NULL;
    gnome_font_picker_uw_set_widget(GNOME_FONT_PICKER(self->obj), GTK_WIDGET(widget->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_uw_get_widget(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_font_picker_uw_get_widget(GNOME_FONT_PICKER(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_font_picker_get_font_name(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_font_picker_get_font_name(GNOME_FONT_PICKER(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_get_font(PyGObject *self)
{
    GdkFont *ret;

    ret = gnome_font_picker_get_font(GNOME_FONT_PICKER(self->obj));
    /* pyg_boxed_new handles NULL checking */
    return pyg_boxed_new(GDK_TYPE_FONT, ret, TRUE, TRUE);
}

static PyObject *
_wrap_gnome_font_picker_set_font_name(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "fontname", NULL };
    char *fontname;
    int ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeFontPicker.set_font_name", kwlist, &fontname))
        return NULL;
    ret = gnome_font_picker_set_font_name(GNOME_FONT_PICKER(self->obj), fontname);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_font_picker_get_preview_text(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_font_picker_get_preview_text(GNOME_FONT_PICKER(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_font_picker_set_preview_text(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "text", NULL };
    char *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeFontPicker.set_preview_text", kwlist, &text))
        return NULL;
    gnome_font_picker_set_preview_text(GNOME_FONT_PICKER(self->obj), text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeFontPicker_methods[] = {
    { "set_title", (PyCFunction)_wrap_gnome_font_picker_set_title, METH_VARARGS|METH_KEYWORDS },
    { "get_title", (PyCFunction)_wrap_gnome_font_picker_get_title, METH_NOARGS },
    { "get_mode", (PyCFunction)_wrap_gnome_font_picker_get_mode, METH_NOARGS },
    { "set_mode", (PyCFunction)_wrap_gnome_font_picker_set_mode, METH_VARARGS|METH_KEYWORDS },
    { "fi_set_use_font_in_label", (PyCFunction)_wrap_gnome_font_picker_fi_set_use_font_in_label, METH_VARARGS|METH_KEYWORDS },
    { "fi_set_show_size", (PyCFunction)_wrap_gnome_font_picker_fi_set_show_size, METH_VARARGS|METH_KEYWORDS },
    { "uw_set_widget", (PyCFunction)_wrap_gnome_font_picker_uw_set_widget, METH_VARARGS|METH_KEYWORDS },
    { "uw_get_widget", (PyCFunction)_wrap_gnome_font_picker_uw_get_widget, METH_NOARGS },
    { "get_font_name", (PyCFunction)_wrap_gnome_font_picker_get_font_name, METH_NOARGS },
    { "get_font", (PyCFunction)_wrap_gnome_font_picker_get_font, METH_NOARGS },
    { "set_font_name", (PyCFunction)_wrap_gnome_font_picker_set_font_name, METH_VARARGS|METH_KEYWORDS },
    { "get_preview_text", (PyCFunction)_wrap_gnome_font_picker_get_preview_text, METH_NOARGS },
    { "set_preview_text", (PyCFunction)_wrap_gnome_font_picker_set_preview_text, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeFontPicker_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.FontPicker",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeFontPicker_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_font_picker_new,		/* tp_init */
};



/* ----------- GnomeHRef ----------- */

static int
_wrap_gnome_href_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "url", "text", NULL };
    char *url, *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeHRef.__init__", kwlist, &url, &text))
        return -1;
    self->obj = (GObject *)gnome_href_new(url, text);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeHRef object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_href_set_url(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "url", NULL };
    char *url;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeHRef.set_url", kwlist, &url))
        return NULL;
    gnome_href_set_url(GNOME_HREF(self->obj), url);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_href_get_url(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_href_get_url(GNOME_HREF(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_href_set_text(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "text", NULL };
    char *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeHRef.set_text", kwlist, &text))
        return NULL;
    gnome_href_set_text(GNOME_HREF(self->obj), text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_href_get_text(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_href_get_text(GNOME_HREF(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_href_set_label(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "label", NULL };
    char *label;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeHRef.set_label", kwlist, &label))
        return NULL;
    gnome_href_set_label(GNOME_HREF(self->obj), label);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_href_get_label(PyGObject *self)
{
    const gchar *ret;

    ret = gnome_href_get_label(GNOME_HREF(self->obj));
    if (ret)
        return PyString_FromString(ret);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeHRef_methods[] = {
    { "set_url", (PyCFunction)_wrap_gnome_href_set_url, METH_VARARGS|METH_KEYWORDS },
    { "get_url", (PyCFunction)_wrap_gnome_href_get_url, METH_NOARGS },
    { "set_text", (PyCFunction)_wrap_gnome_href_set_text, METH_VARARGS|METH_KEYWORDS },
    { "get_text", (PyCFunction)_wrap_gnome_href_get_text, METH_NOARGS },
    { "set_label", (PyCFunction)_wrap_gnome_href_set_label, METH_VARARGS|METH_KEYWORDS },
    { "get_label", (PyCFunction)_wrap_gnome_href_get_label, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeHRef_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.HRef",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeHRef_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_href_new,		/* tp_init */
};



/* ----------- GnomeIconEntry ----------- */

static int
_wrap_gnome_icon_entry_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", "browse_dialog_title", NULL };
    char *history_id, *browse_dialog_title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeIconEntry.__init__", kwlist, &history_id, &browse_dialog_title))
        return -1;
    self->obj = (GObject *)gnome_icon_entry_new(history_id, browse_dialog_title);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeIconEntry object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_icon_entry_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", "browse_dialog_title", NULL };
    char *history_id, *browse_dialog_title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeIconEntry.construct", kwlist, &history_id, &browse_dialog_title))
        return NULL;
    gnome_icon_entry_construct(GNOME_ICON_ENTRY(self->obj), history_id, browse_dialog_title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_entry_set_pixmap_subdir(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "subdir", NULL };
    char *subdir;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconEntry.set_pixmap_subdir", kwlist, &subdir))
        return NULL;
    gnome_icon_entry_set_pixmap_subdir(GNOME_ICON_ENTRY(self->obj), subdir);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_entry_get_filename(PyGObject *self)
{
    gchar *ret;

    ret = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_entry_set_filename(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;
    int ret;
    PyObject *py_ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconEntry.set_filename", kwlist, &filename))
        return NULL;
    ret = gnome_icon_entry_set_filename(GNOME_ICON_ENTRY(self->obj), filename);
    py_ret = ret ? Py_True : Py_False;
    Py_INCREF(py_ret);
    return py_ret;
}

static PyObject *
_wrap_gnome_icon_entry_set_browse_dialog_title(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "browse_dialog_title", NULL };
    char *browse_dialog_title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconEntry.set_browse_dialog_title", kwlist, &browse_dialog_title))
        return NULL;
    gnome_icon_entry_set_browse_dialog_title(GNOME_ICON_ENTRY(self->obj), browse_dialog_title);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_entry_set_history_id(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", NULL };
    char *history_id;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconEntry.set_history_id", kwlist, &history_id))
        return NULL;
    gnome_icon_entry_set_history_id(GNOME_ICON_ENTRY(self->obj), history_id);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_entry_pick_dialog(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_icon_entry_pick_dialog(GNOME_ICON_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_icon_entry_set_icon(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconEntry.set_icon", kwlist, &filename))
        return NULL;
    gnome_icon_entry_set_icon(GNOME_ICON_ENTRY(self->obj), filename);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_entry_gnome_file_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_icon_entry_gnome_file_entry(GNOME_ICON_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_icon_entry_gnome_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_icon_entry_gnome_entry(GNOME_ICON_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_icon_entry_gtk_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_icon_entry_gtk_entry(GNOME_ICON_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyGnomeIconEntry_methods[] = {
    { "construct", (PyCFunction)_wrap_gnome_icon_entry_construct, METH_VARARGS|METH_KEYWORDS },
    { "set_pixmap_subdir", (PyCFunction)_wrap_gnome_icon_entry_set_pixmap_subdir, METH_VARARGS|METH_KEYWORDS },
    { "get_filename", (PyCFunction)_wrap_gnome_icon_entry_get_filename, METH_NOARGS },
    { "set_filename", (PyCFunction)_wrap_gnome_icon_entry_set_filename, METH_VARARGS|METH_KEYWORDS },
    { "set_browse_dialog_title", (PyCFunction)_wrap_gnome_icon_entry_set_browse_dialog_title, METH_VARARGS|METH_KEYWORDS },
    { "set_history_id", (PyCFunction)_wrap_gnome_icon_entry_set_history_id, METH_VARARGS|METH_KEYWORDS },
    { "pick_dialog", (PyCFunction)_wrap_gnome_icon_entry_pick_dialog, METH_NOARGS },
    { "set_icon", (PyCFunction)_wrap_gnome_icon_entry_set_icon, METH_VARARGS|METH_KEYWORDS },
    { "gnome_file_entry", (PyCFunction)_wrap_gnome_icon_entry_gnome_file_entry, METH_NOARGS },
    { "gnome_entry", (PyCFunction)_wrap_gnome_icon_entry_gnome_entry, METH_NOARGS },
    { "gtk_entry", (PyCFunction)_wrap_gnome_icon_entry_gtk_entry, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeIconEntry_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.IconEntry",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeIconEntry_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_icon_entry_new,		/* tp_init */
};



/* ----------- GnomeIconList ----------- */

static int
_wrap_gnome_icon_list_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "icon_width", "adj", "flags", NULL };
    int icon_width, flags;
    PyGObject *adj;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iO!i:GnomeIconList.__init__", kwlist, &icon_width, &PyGtkAdjustment_Type, &adj, &flags))
        return -1;
    self->obj = (GObject *)gnome_icon_list_new(icon_width, GTK_ADJUSTMENT(adj->obj), flags);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeIconList object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_icon_list_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "icon_width", "adj", "flags", NULL };
    int icon_width, flags;
    PyGObject *adj;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iO!i:GnomeIconList.construct", kwlist, &icon_width, &PyGtkAdjustment_Type, &adj, &flags))
        return NULL;
    gnome_icon_list_construct(GNOME_ICON_LIST(self->obj), icon_width, GTK_ADJUSTMENT(adj->obj), flags);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_hadjustment(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "hadj", NULL };
    PyGObject *hadj;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeIconList.set_hadjustment", kwlist, &PyGtkAdjustment_Type, &hadj))
        return NULL;
    gnome_icon_list_set_hadjustment(GNOME_ICON_LIST(self->obj), GTK_ADJUSTMENT(hadj->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_vadjustment(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "vadj", NULL };
    PyGObject *vadj;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeIconList.set_vadjustment", kwlist, &PyGtkAdjustment_Type, &vadj))
        return NULL;
    gnome_icon_list_set_vadjustment(GNOME_ICON_LIST(self->obj), GTK_ADJUSTMENT(vadj->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_freeze(PyGObject *self)
{
    gnome_icon_list_freeze(GNOME_ICON_LIST(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_thaw(PyGObject *self)
{
    gnome_icon_list_thaw(GNOME_ICON_LIST(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_insert(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", "icon_filename", "text", NULL };
    int idx;
    char *icon_filename, *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iss:GnomeIconList.insert", kwlist, &idx, &icon_filename, &text))
        return NULL;
    gnome_icon_list_insert(GNOME_ICON_LIST(self->obj), idx, icon_filename, text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_insert_pixbuf(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", "im", "icon_filename", "text", NULL };
    int idx;
    PyGObject *im;
    char *icon_filename, *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iO!ss:GnomeIconList.insert_pixbuf", kwlist, &idx, &PyGdkPixbuf_Type, &im, &icon_filename, &text))
        return NULL;
    gnome_icon_list_insert_pixbuf(GNOME_ICON_LIST(self->obj), idx, GDK_PIXBUF(im->obj), icon_filename, text);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_append(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "icon_filename", "text", NULL };
    char *icon_filename, *text;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeIconList.append", kwlist, &icon_filename, &text))
        return NULL;
    ret = gnome_icon_list_append(GNOME_ICON_LIST(self->obj), icon_filename, text);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_append_pixbuf(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "im", "icon_filename", "text", NULL };
    PyGObject *im;
    char *icon_filename, *text;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!ss:GnomeIconList.append_pixbuf", kwlist, &PyGdkPixbuf_Type, &im, &icon_filename, &text))
        return NULL;
    ret = gnome_icon_list_append_pixbuf(GNOME_ICON_LIST(self->obj), GDK_PIXBUF(im->obj), icon_filename, text);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_clear(PyGObject *self)
{
    gnome_icon_list_clear(GNOME_ICON_LIST(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_remove(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", NULL };
    int idx;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.remove", kwlist, &idx))
        return NULL;
    gnome_icon_list_remove(GNOME_ICON_LIST(self->obj), idx);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_get_num_icons(PyGObject *self)
{
    int ret;

    ret = gnome_icon_list_get_num_icons(GNOME_ICON_LIST(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_get_selection_mode(PyGObject *self)
{
    gint ret;

    ret = gnome_icon_list_get_selection_mode(GNOME_ICON_LIST(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_set_selection_mode(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "mode", NULL };
    PyObject *py_mode = NULL;
    GtkSelectionMode mode;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeIconList.set_selection_mode", kwlist, &py_mode))
        return NULL;
    if (pyg_enum_get_value(GTK_TYPE_SELECTION_MODE, py_mode, (gint *)&mode))
        return NULL;
    gnome_icon_list_set_selection_mode(GNOME_ICON_LIST(self->obj), mode);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_select_icon(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", NULL };
    int idx;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.select_icon", kwlist, &idx))
        return NULL;
    gnome_icon_list_select_icon(GNOME_ICON_LIST(self->obj), idx);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_unselect_icon(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", NULL };
    int idx;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.unselect_icon", kwlist, &idx))
        return NULL;
    gnome_icon_list_unselect_icon(GNOME_ICON_LIST(self->obj), idx);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_unselect_all(PyGObject *self)
{
    int ret;

    ret = gnome_icon_list_unselect_all(GNOME_ICON_LIST(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_focus_icon(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", NULL };
    int idx;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.focus_icon", kwlist, &idx))
        return NULL;
    gnome_icon_list_focus_icon(GNOME_ICON_LIST(self->obj), idx);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_icon_width(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "w", NULL };
    int w;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.set_icon_width", kwlist, &w))
        return NULL;
    gnome_icon_list_set_icon_width(GNOME_ICON_LIST(self->obj), w);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_row_spacing(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pixels", NULL };
    int pixels;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.set_row_spacing", kwlist, &pixels))
        return NULL;
    gnome_icon_list_set_row_spacing(GNOME_ICON_LIST(self->obj), pixels);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_col_spacing(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pixels", NULL };
    int pixels;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.set_col_spacing", kwlist, &pixels))
        return NULL;
    gnome_icon_list_set_col_spacing(GNOME_ICON_LIST(self->obj), pixels);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_text_spacing(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pixels", NULL };
    int pixels;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.set_text_spacing", kwlist, &pixels))
        return NULL;
    gnome_icon_list_set_text_spacing(GNOME_ICON_LIST(self->obj), pixels);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_icon_border(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pixels", NULL };
    int pixels;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.set_icon_border", kwlist, &pixels))
        return NULL;
    gnome_icon_list_set_icon_border(GNOME_ICON_LIST(self->obj), pixels);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_set_separators(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "sep", NULL };
    char *sep;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconList.set_separators", kwlist, &sep))
        return NULL;
    gnome_icon_list_set_separators(GNOME_ICON_LIST(self->obj), sep);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_get_icon_filename(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", NULL };
    int idx;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.get_icon_filename", kwlist, &idx))
        return NULL;
    ret = gnome_icon_list_get_icon_filename(GNOME_ICON_LIST(self->obj), idx);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_find_icon_from_filename(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconList.find_icon_from_filename", kwlist, &filename))
        return NULL;
    ret = gnome_icon_list_find_icon_from_filename(GNOME_ICON_LIST(self->obj), filename);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_moveto(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", "yalign", NULL };
    int idx;
    double yalign;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "id:GnomeIconList.moveto", kwlist, &idx, &yalign))
        return NULL;
    gnome_icon_list_moveto(GNOME_ICON_LIST(self->obj), idx, yalign);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_list_icon_is_visible(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", NULL };
    int idx;
    gint ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.icon_is_visible", kwlist, &idx))
        return NULL;
    ret = gnome_icon_list_icon_is_visible(GNOME_ICON_LIST(self->obj), idx);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_get_icon_at(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", NULL };
    int x, y, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:GnomeIconList.get_icon_at", kwlist, &x, &y))
        return NULL;
    ret = gnome_icon_list_get_icon_at(GNOME_ICON_LIST(self->obj), x, y);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_get_items_per_line(PyGObject *self)
{
    int ret;

    ret = gnome_icon_list_get_items_per_line(GNOME_ICON_LIST(self->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_icon_list_get_icon_text_item(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "idx", NULL };
    int idx;
    GnomeIconTextItem *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconList.get_icon_text_item", kwlist, &idx))
        return NULL;
    ret = gnome_icon_list_get_icon_text_item(GNOME_ICON_LIST(self->obj), idx);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyGnomeIconList_methods[] = {
    { "construct", (PyCFunction)_wrap_gnome_icon_list_construct, METH_VARARGS|METH_KEYWORDS },
    { "set_hadjustment", (PyCFunction)_wrap_gnome_icon_list_set_hadjustment, METH_VARARGS|METH_KEYWORDS },
    { "set_vadjustment", (PyCFunction)_wrap_gnome_icon_list_set_vadjustment, METH_VARARGS|METH_KEYWORDS },
    { "freeze", (PyCFunction)_wrap_gnome_icon_list_freeze, METH_NOARGS },
    { "thaw", (PyCFunction)_wrap_gnome_icon_list_thaw, METH_NOARGS },
    { "insert", (PyCFunction)_wrap_gnome_icon_list_insert, METH_VARARGS|METH_KEYWORDS },
    { "insert_pixbuf", (PyCFunction)_wrap_gnome_icon_list_insert_pixbuf, METH_VARARGS|METH_KEYWORDS },
    { "append", (PyCFunction)_wrap_gnome_icon_list_append, METH_VARARGS|METH_KEYWORDS },
    { "append_pixbuf", (PyCFunction)_wrap_gnome_icon_list_append_pixbuf, METH_VARARGS|METH_KEYWORDS },
    { "clear", (PyCFunction)_wrap_gnome_icon_list_clear, METH_NOARGS },
    { "remove", (PyCFunction)_wrap_gnome_icon_list_remove, METH_VARARGS|METH_KEYWORDS },
    { "get_num_icons", (PyCFunction)_wrap_gnome_icon_list_get_num_icons, METH_NOARGS },
    { "get_selection_mode", (PyCFunction)_wrap_gnome_icon_list_get_selection_mode, METH_NOARGS },
    { "set_selection_mode", (PyCFunction)_wrap_gnome_icon_list_set_selection_mode, METH_VARARGS|METH_KEYWORDS },
    { "select_icon", (PyCFunction)_wrap_gnome_icon_list_select_icon, METH_VARARGS|METH_KEYWORDS },
    { "unselect_icon", (PyCFunction)_wrap_gnome_icon_list_unselect_icon, METH_VARARGS|METH_KEYWORDS },
    { "unselect_all", (PyCFunction)_wrap_gnome_icon_list_unselect_all, METH_NOARGS },
    { "focus_icon", (PyCFunction)_wrap_gnome_icon_list_focus_icon, METH_VARARGS|METH_KEYWORDS },
    { "set_icon_width", (PyCFunction)_wrap_gnome_icon_list_set_icon_width, METH_VARARGS|METH_KEYWORDS },
    { "set_row_spacing", (PyCFunction)_wrap_gnome_icon_list_set_row_spacing, METH_VARARGS|METH_KEYWORDS },
    { "set_col_spacing", (PyCFunction)_wrap_gnome_icon_list_set_col_spacing, METH_VARARGS|METH_KEYWORDS },
    { "set_text_spacing", (PyCFunction)_wrap_gnome_icon_list_set_text_spacing, METH_VARARGS|METH_KEYWORDS },
    { "set_icon_border", (PyCFunction)_wrap_gnome_icon_list_set_icon_border, METH_VARARGS|METH_KEYWORDS },
    { "set_separators", (PyCFunction)_wrap_gnome_icon_list_set_separators, METH_VARARGS|METH_KEYWORDS },
    { "get_icon_filename", (PyCFunction)_wrap_gnome_icon_list_get_icon_filename, METH_VARARGS|METH_KEYWORDS },
    { "find_icon_from_filename", (PyCFunction)_wrap_gnome_icon_list_find_icon_from_filename, METH_VARARGS|METH_KEYWORDS },
    { "moveto", (PyCFunction)_wrap_gnome_icon_list_moveto, METH_VARARGS|METH_KEYWORDS },
    { "icon_is_visible", (PyCFunction)_wrap_gnome_icon_list_icon_is_visible, METH_VARARGS|METH_KEYWORDS },
    { "get_icon_at", (PyCFunction)_wrap_gnome_icon_list_get_icon_at, METH_VARARGS|METH_KEYWORDS },
    { "get_items_per_line", (PyCFunction)_wrap_gnome_icon_list_get_items_per_line, METH_NOARGS },
    { "get_icon_text_item", (PyCFunction)_wrap_gnome_icon_list_get_icon_text_item, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeIconList_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.IconList",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeIconList_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_icon_list_new,		/* tp_init */
};



/* ----------- GnomeIconSelection ----------- */

static int
_wrap_gnome_icon_selection_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomeIconSelection.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_icon_selection_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeIconSelection object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_icon_selection_add_defaults(PyGObject *self)
{
    gnome_icon_selection_add_defaults(GNOME_ICON_SELECTION(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_selection_add_directory(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "dir", NULL };
    char *dir;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconSelection.add_directory", kwlist, &dir))
        return NULL;
    gnome_icon_selection_add_directory(GNOME_ICON_SELECTION(self->obj), dir);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_selection_show_icons(PyGObject *self)
{
    gnome_icon_selection_show_icons(GNOME_ICON_SELECTION(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_selection_clear(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "not_shown", NULL };
    int not_shown;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconSelection.clear", kwlist, &not_shown))
        return NULL;
    gnome_icon_selection_clear(GNOME_ICON_SELECTION(self->obj), not_shown);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_selection_get_icon(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "full_path", NULL };
    int full_path;
    gchar *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconSelection.get_icon", kwlist, &full_path))
        return NULL;
    ret = gnome_icon_selection_get_icon(GNOME_ICON_SELECTION(self->obj), full_path);
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_selection_select_icon(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeIconSelection.select_icon", kwlist, &filename))
        return NULL;
    gnome_icon_selection_select_icon(GNOME_ICON_SELECTION(self->obj), filename);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_selection_stop_loading(PyGObject *self)
{
    gnome_icon_selection_stop_loading(GNOME_ICON_SELECTION(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_selection_get_gil(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_icon_selection_get_gil(GNOME_ICON_SELECTION(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_icon_selection_get_box(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_icon_selection_get_box(GNOME_ICON_SELECTION(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyMethodDef _PyGnomeIconSelection_methods[] = {
    { "add_defaults", (PyCFunction)_wrap_gnome_icon_selection_add_defaults, METH_NOARGS },
    { "add_directory", (PyCFunction)_wrap_gnome_icon_selection_add_directory, METH_VARARGS|METH_KEYWORDS },
    { "show_icons", (PyCFunction)_wrap_gnome_icon_selection_show_icons, METH_NOARGS },
    { "clear", (PyCFunction)_wrap_gnome_icon_selection_clear, METH_VARARGS|METH_KEYWORDS },
    { "get_icon", (PyCFunction)_wrap_gnome_icon_selection_get_icon, METH_VARARGS|METH_KEYWORDS },
    { "select_icon", (PyCFunction)_wrap_gnome_icon_selection_select_icon, METH_VARARGS|METH_KEYWORDS },
    { "stop_loading", (PyCFunction)_wrap_gnome_icon_selection_stop_loading, METH_NOARGS },
    { "get_gil", (PyCFunction)_wrap_gnome_icon_selection_get_gil, METH_NOARGS },
    { "get_box", (PyCFunction)_wrap_gnome_icon_selection_get_box, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeIconSelection_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.IconSelection",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeIconSelection_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_icon_selection_new,		/* tp_init */
};



/* ----------- GnomeIconTextItem ----------- */

static PyObject *
_wrap_gnome_icon_text_item_configure(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", "width", "fontname", "text", "is_editable", "is_static", NULL };
    int x, y, width, is_editable, is_static;
    char *fontname, *text;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "iiissii:GnomeIconTextItem.configure", kwlist, &x, &y, &width, &fontname, &text, &is_editable, &is_static))
        return NULL;
    gnome_icon_text_item_configure(GNOME_ICON_TEXT_ITEM(self->obj), x, y, width, fontname, text, is_editable, is_static);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_text_item_setxy(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "x", "y", NULL };
    int x, y;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:GnomeIconTextItem.setxy", kwlist, &x, &y))
        return NULL;
    gnome_icon_text_item_setxy(GNOME_ICON_TEXT_ITEM(self->obj), x, y);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_text_item_select(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "sel", NULL };
    int sel;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconTextItem.select", kwlist, &sel))
        return NULL;
    gnome_icon_text_item_select(GNOME_ICON_TEXT_ITEM(self->obj), sel);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_text_item_focus(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "focused", NULL };
    int focused;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconTextItem.focus", kwlist, &focused))
        return NULL;
    gnome_icon_text_item_focus(GNOME_ICON_TEXT_ITEM(self->obj), focused);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_text_item_start_editing(PyGObject *self)
{
    gnome_icon_text_item_start_editing(GNOME_ICON_TEXT_ITEM(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_icon_text_item_stop_editing(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "accept", NULL };
    int accept;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeIconTextItem.stop_editing", kwlist, &accept))
        return NULL;
    gnome_icon_text_item_stop_editing(GNOME_ICON_TEXT_ITEM(self->obj), accept);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeIconTextItem_methods[] = {
    { "configure", (PyCFunction)_wrap_gnome_icon_text_item_configure, METH_VARARGS|METH_KEYWORDS },
    { "setxy", (PyCFunction)_wrap_gnome_icon_text_item_setxy, METH_VARARGS|METH_KEYWORDS },
    { "select", (PyCFunction)_wrap_gnome_icon_text_item_select, METH_VARARGS|METH_KEYWORDS },
    { "focus", (PyCFunction)_wrap_gnome_icon_text_item_focus, METH_VARARGS|METH_KEYWORDS },
    { "start_editing", (PyCFunction)_wrap_gnome_icon_text_item_start_editing, METH_NOARGS },
    { "stop_editing", (PyCFunction)_wrap_gnome_icon_text_item_stop_editing, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeIconTextItem_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.IconTextItem",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeIconTextItem_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- GnomeMDI ----------- */

static int
_wrap_gnome_mdi_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "appname", "title", NULL };
    char *appname, *title;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ss:GnomeMDI.__init__", kwlist, &appname, &title))
        return -1;
    self->obj = (GObject *)gnome_mdi_new(appname, title);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeMDI object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_mdi_set_mode(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "mode", NULL };
    PyObject *py_mode = NULL;
    GnomeMDIMode mode;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O:GnomeMDI.set_mode", kwlist, &py_mode))
        return NULL;
    if (pyg_enum_get_value(GNOME_TYPE_MDI_MODE, py_mode, (gint *)&mode))
        return NULL;
    gnome_mdi_set_mode(GNOME_MDI(self->obj), mode);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_set_child_menu_path(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeMDI.set_child_menu_path", kwlist, &path))
        return NULL;
    gnome_mdi_set_child_menu_path(GNOME_MDI(self->obj), path);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_set_child_list_path(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "path", NULL };
    char *path;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeMDI.set_child_list_path", kwlist, &path))
        return NULL;
    gnome_mdi_set_child_list_path(GNOME_MDI(self->obj), path);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_add_view(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", NULL };
    PyGObject *child;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.add_view", kwlist, &PyGnomeMDIChild_Type, &child))
        return NULL;
    ret = gnome_mdi_add_view(GNOME_MDI(self->obj), GNOME_MDI_CHILD(child->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_mdi_add_toplevel_view(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", NULL };
    PyGObject *child;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.add_toplevel_view", kwlist, &PyGnomeMDIChild_Type, &child))
        return NULL;
    ret = gnome_mdi_add_toplevel_view(GNOME_MDI(self->obj), GNOME_MDI_CHILD(child->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_mdi_remove_view(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", "force", NULL };
    PyGObject *view;
    int force, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!i:GnomeMDI.remove_view", kwlist, &PyGtkWidget_Type, &view, &force))
        return NULL;
    ret = gnome_mdi_remove_view(GNOME_MDI(self->obj), GTK_WIDGET(view->obj), force);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_mdi_get_active_view(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_mdi_get_active_view(GNOME_MDI(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_mdi_set_active_view(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", NULL };
    PyGObject *view;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.set_active_view", kwlist, &PyGtkWidget_Type, &view))
        return NULL;
    gnome_mdi_set_active_view(GNOME_MDI(self->obj), GTK_WIDGET(view->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_add_child(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", NULL };
    PyGObject *child;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.add_child", kwlist, &PyGnomeMDIChild_Type, &child))
        return NULL;
    ret = gnome_mdi_add_child(GNOME_MDI(self->obj), GNOME_MDI_CHILD(child->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_mdi_remove_child(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", "force", NULL };
    PyGObject *child;
    int force, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!i:GnomeMDI.remove_child", kwlist, &PyGnomeMDIChild_Type, &child, &force))
        return NULL;
    ret = gnome_mdi_remove_child(GNOME_MDI(self->obj), GNOME_MDI_CHILD(child->obj), force);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_mdi_remove_all(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "force", NULL };
    int force, ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomeMDI.remove_all", kwlist, &force))
        return NULL;
    ret = gnome_mdi_remove_all(GNOME_MDI(self->obj), force);
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_mdi_open_toplevel(PyGObject *self)
{
    gnome_mdi_open_toplevel(GNOME_MDI(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_update_child(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", NULL };
    PyGObject *child;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.update_child", kwlist, &PyGnomeMDIChild_Type, &child))
        return NULL;
    gnome_mdi_update_child(GNOME_MDI(self->obj), GNOME_MDI_CHILD(child->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_get_active_child(PyGObject *self)
{
    GnomeMDIChild *ret;

    ret = gnome_mdi_get_active_child(GNOME_MDI(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_mdi_find_child(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;
    GnomeMDIChild *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeMDI.find_child", kwlist, &name))
        return NULL;
    ret = gnome_mdi_find_child(GNOME_MDI(self->obj), name);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_mdi_get_active_window(PyGObject *self)
{
    GnomeApp *ret;

    ret = gnome_mdi_get_active_window(GNOME_MDI(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_mdi_register(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", NULL };
    PyGObject *object;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.register", kwlist, &PyGtkObject_Type, &object))
        return NULL;
    gnome_mdi_register(GNOME_MDI(self->obj), GTK_OBJECT(object->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_unregister(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "object", NULL };
    PyGObject *object;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.unregister", kwlist, &PyGtkObject_Type, &object))
        return NULL;
    gnome_mdi_unregister(GNOME_MDI(self->obj), GTK_OBJECT(object->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_get_view_from_window(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "app", NULL };
    PyGObject *app;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDI.get_view_from_window", kwlist, &PyGnomeApp_Type, &app))
        return NULL;
    ret = gnome_mdi_get_view_from_window(GNOME_MDI(self->obj), GNOME_APP(app->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_mdi_save_state(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "section", NULL };
    char *section;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeMDI.save_state", kwlist, &section))
        return NULL;
    gnome_mdi_save_state(GNOME_MDI(self->obj), section);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeMDI_methods[] = {
    { "set_mode", (PyCFunction)_wrap_gnome_mdi_set_mode, METH_VARARGS|METH_KEYWORDS },
    { "set_child_menu_path", (PyCFunction)_wrap_gnome_mdi_set_child_menu_path, METH_VARARGS|METH_KEYWORDS },
    { "set_child_list_path", (PyCFunction)_wrap_gnome_mdi_set_child_list_path, METH_VARARGS|METH_KEYWORDS },
    { "add_view", (PyCFunction)_wrap_gnome_mdi_add_view, METH_VARARGS|METH_KEYWORDS },
    { "add_toplevel_view", (PyCFunction)_wrap_gnome_mdi_add_toplevel_view, METH_VARARGS|METH_KEYWORDS },
    { "remove_view", (PyCFunction)_wrap_gnome_mdi_remove_view, METH_VARARGS|METH_KEYWORDS },
    { "get_active_view", (PyCFunction)_wrap_gnome_mdi_get_active_view, METH_NOARGS },
    { "set_active_view", (PyCFunction)_wrap_gnome_mdi_set_active_view, METH_VARARGS|METH_KEYWORDS },
    { "add_child", (PyCFunction)_wrap_gnome_mdi_add_child, METH_VARARGS|METH_KEYWORDS },
    { "remove_child", (PyCFunction)_wrap_gnome_mdi_remove_child, METH_VARARGS|METH_KEYWORDS },
    { "remove_all", (PyCFunction)_wrap_gnome_mdi_remove_all, METH_VARARGS|METH_KEYWORDS },
    { "open_toplevel", (PyCFunction)_wrap_gnome_mdi_open_toplevel, METH_NOARGS },
    { "update_child", (PyCFunction)_wrap_gnome_mdi_update_child, METH_VARARGS|METH_KEYWORDS },
    { "get_active_child", (PyCFunction)_wrap_gnome_mdi_get_active_child, METH_NOARGS },
    { "find_child", (PyCFunction)_wrap_gnome_mdi_find_child, METH_VARARGS|METH_KEYWORDS },
    { "get_active_window", (PyCFunction)_wrap_gnome_mdi_get_active_window, METH_NOARGS },
    { "register", (PyCFunction)_wrap_gnome_mdi_register, METH_VARARGS|METH_KEYWORDS },
    { "unregister", (PyCFunction)_wrap_gnome_mdi_unregister, METH_VARARGS|METH_KEYWORDS },
    { "get_view_from_window", (PyCFunction)_wrap_gnome_mdi_get_view_from_window, METH_VARARGS|METH_KEYWORDS },
    { "save_state", (PyCFunction)_wrap_gnome_mdi_save_state, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeMDI_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.MDI",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeMDI_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_mdi_new,		/* tp_init */
};



/* ----------- GnomeMDIChild ----------- */

static PyObject *
_wrap_gnome_mdi_child_add_view(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_mdi_child_add_view(GNOME_MDI_CHILD(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_mdi_child_remove_view(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", NULL };
    PyGObject *view;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomeMDIChild.remove_view", kwlist, &PyGtkWidget_Type, &view))
        return NULL;
    gnome_mdi_child_remove_view(GNOME_MDI_CHILD(self->obj), GTK_WIDGET(view->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_mdi_child_set_name(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeMDIChild.set_name", kwlist, &name))
        return NULL;
    gnome_mdi_child_set_name(GNOME_MDI_CHILD(self->obj), name);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomeMDIChild_methods[] = {
    { "add_view", (PyCFunction)_wrap_gnome_mdi_child_add_view, METH_NOARGS },
    { "remove_view", (PyCFunction)_wrap_gnome_mdi_child_remove_view, METH_VARARGS|METH_KEYWORDS },
    { "set_name", (PyCFunction)_wrap_gnome_mdi_child_set_name, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomeMDIChild_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.MDIChild",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomeMDIChild_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- GnomeMDIGenericChild ----------- */

static int
_wrap_gnome_mdi_generic_child_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "name", NULL };
    char *name;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomeMDIGenericChild.__init__", kwlist, &name))
        return -1;
    self->obj = (GObject *)gnome_mdi_generic_child_new(name);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomeMDIGenericChild object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

PyTypeObject PyGnomeMDIGenericChild_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.MDIGenericChild",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_mdi_generic_child_new,		/* tp_init */
};



/* ----------- GnomeMessageBox ----------- */

PyTypeObject PyGnomeMessageBox_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.MessageBox",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- GnomePixmap ----------- */

static int
_wrap_gnome_pixmap_new_from_gnome_pixmap(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "gpixmap", NULL };
    PyGObject *gpixmap;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:GnomePixmap.__init__", kwlist, &PyGnomePixmap_Type, &gpixmap))
        return -1;
    self->obj = (GObject *)gnome_pixmap_new_from_gnome_pixmap(GNOME_PIXMAP(gpixmap->obj));

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomePixmap object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_pixmap_load_file(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomePixmap.load_file", kwlist, &filename))
        return NULL;
    gnome_pixmap_load_file(GNOME_PIXMAP(self->obj), filename);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_pixmap_load_file_at_size(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", "width", "height", NULL };
    char *filename;
    int width, height;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sii:GnomePixmap.load_file_at_size", kwlist, &filename, &width, &height))
        return NULL;
    gnome_pixmap_load_file_at_size(GNOME_PIXMAP(self->obj), filename, width, height);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomePixmap_methods[] = {
    { "load_file", (PyCFunction)_wrap_gnome_pixmap_load_file, METH_VARARGS|METH_KEYWORDS },
    { "load_file_at_size", (PyCFunction)_wrap_gnome_pixmap_load_file_at_size, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomePixmap_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.Pixmap",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomePixmap_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_pixmap_new_from_gnome_pixmap,		/* tp_init */
};



/* ----------- GnomePixmapEntry ----------- */

static int
_wrap_gnome_pixmap_entry_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", "browse_dialog_title", "do_preview", NULL };
    char *history_id, *browse_dialog_title;
    int do_preview;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ssi:GnomePixmapEntry.__init__", kwlist, &history_id, &browse_dialog_title, &do_preview))
        return -1;
    self->obj = (GObject *)gnome_pixmap_entry_new(history_id, browse_dialog_title, do_preview);

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomePixmapEntry object");
        return -1;
    }
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_pixmap_entry_construct(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "history_id", "browse_dialog_title", "do_preview", NULL };
    char *history_id, *browse_dialog_title;
    int do_preview;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ssi:GnomePixmapEntry.construct", kwlist, &history_id, &browse_dialog_title, &do_preview))
        return NULL;
    gnome_pixmap_entry_construct(GNOME_PIXMAP_ENTRY(self->obj), history_id, browse_dialog_title, do_preview);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_pixmap_entry_set_pixmap_subdir(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "subdir", NULL };
    char *subdir;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:GnomePixmapEntry.set_pixmap_subdir", kwlist, &subdir))
        return NULL;
    gnome_pixmap_entry_set_pixmap_subdir(GNOME_PIXMAP_ENTRY(self->obj), subdir);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_pixmap_entry_gnome_file_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_pixmap_entry_gnome_file_entry(GNOME_PIXMAP_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_pixmap_entry_gnome_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_pixmap_entry_gnome_entry(GNOME_PIXMAP_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_pixmap_entry_gtk_entry(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_pixmap_entry_gtk_entry(GNOME_PIXMAP_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_pixmap_entry_scrolled_window(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_pixmap_entry_scrolled_window(GNOME_PIXMAP_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_pixmap_entry_preview_widget(PyGObject *self)
{
    GtkWidget *ret;

    ret = gnome_pixmap_entry_preview_widget(GNOME_PIXMAP_ENTRY(self->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_pixmap_entry_set_preview(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "do_preview", NULL };
    int do_preview;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomePixmapEntry.set_preview", kwlist, &do_preview))
        return NULL;
    gnome_pixmap_entry_set_preview(GNOME_PIXMAP_ENTRY(self->obj), do_preview);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_pixmap_entry_set_preview_size(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "preview_w", "preview_h", NULL };
    int preview_w, preview_h;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:GnomePixmapEntry.set_preview_size", kwlist, &preview_w, &preview_h))
        return NULL;
    gnome_pixmap_entry_set_preview_size(GNOME_PIXMAP_ENTRY(self->obj), preview_w, preview_h);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_pixmap_entry_get_filename(PyGObject *self)
{
    gchar *ret;

    ret = gnome_pixmap_entry_get_filename(GNOME_PIXMAP_ENTRY(self->obj));
    if (ret) {
        PyObject *py_ret = PyString_FromString(ret);
        g_free(ret);
        return py_ret;
    }
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomePixmapEntry_methods[] = {
    { "construct", (PyCFunction)_wrap_gnome_pixmap_entry_construct, METH_VARARGS|METH_KEYWORDS },
    { "set_pixmap_subdir", (PyCFunction)_wrap_gnome_pixmap_entry_set_pixmap_subdir, METH_VARARGS|METH_KEYWORDS },
    { "gnome_file_entry", (PyCFunction)_wrap_gnome_pixmap_entry_gnome_file_entry, METH_NOARGS },
    { "gnome_entry", (PyCFunction)_wrap_gnome_pixmap_entry_gnome_entry, METH_NOARGS },
    { "gtk_entry", (PyCFunction)_wrap_gnome_pixmap_entry_gtk_entry, METH_NOARGS },
    { "scrolled_window", (PyCFunction)_wrap_gnome_pixmap_entry_scrolled_window, METH_NOARGS },
    { "preview_widget", (PyCFunction)_wrap_gnome_pixmap_entry_preview_widget, METH_NOARGS },
    { "set_preview", (PyCFunction)_wrap_gnome_pixmap_entry_set_preview, METH_VARARGS|METH_KEYWORDS },
    { "set_preview_size", (PyCFunction)_wrap_gnome_pixmap_entry_set_preview_size, METH_VARARGS|METH_KEYWORDS },
    { "get_filename", (PyCFunction)_wrap_gnome_pixmap_entry_get_filename, METH_NOARGS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomePixmapEntry_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.PixmapEntry",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomePixmapEntry_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_pixmap_entry_new,		/* tp_init */
};



/* ----------- GnomePropertyBox ----------- */

static int
_wrap_gnome_property_box_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { NULL };

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, ":GnomePropertyBox.__init__", kwlist))
        return -1;
    self->obj = (GObject *)gnome_property_box_new();

    if (!self->obj) {
        PyErr_SetString(PyExc_RuntimeError, "could not create GnomePropertyBox object");
        return -1;
    }
    g_object_ref(self->obj); /* we don't own the first reference of windows */
    pygobject_register_wrapper((PyObject *)self);
    return 0;
}

static PyObject *
_wrap_gnome_property_box_changed(PyGObject *self)
{
    gnome_property_box_changed(GNOME_PROPERTY_BOX(self->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_property_box_set_modified(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "state", NULL };
    int state;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomePropertyBox.set_modified", kwlist, &state))
        return NULL;
    gnome_property_box_set_modified(GNOME_PROPERTY_BOX(self->obj), state);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_property_box_append_page(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "child", "tab_label", NULL };
    PyGObject *child, *tab_label;
    int ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O!:GnomePropertyBox.append_page", kwlist, &PyGtkWidget_Type, &child, &PyGtkWidget_Type, &tab_label))
        return NULL;
    ret = gnome_property_box_append_page(GNOME_PROPERTY_BOX(self->obj), GTK_WIDGET(child->obj), GTK_WIDGET(tab_label->obj));
    return PyInt_FromLong(ret);
}

static PyObject *
_wrap_gnome_property_box_set_state(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "state", NULL };
    int state;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i:GnomePropertyBox.set_state", kwlist, &state))
        return NULL;
    gnome_property_box_set_state(GNOME_PROPERTY_BOX(self->obj), state);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyMethodDef _PyGnomePropertyBox_methods[] = {
    { "changed", (PyCFunction)_wrap_gnome_property_box_changed, METH_NOARGS },
    { "set_modified", (PyCFunction)_wrap_gnome_property_box_set_modified, METH_VARARGS|METH_KEYWORDS },
    { "append_page", (PyCFunction)_wrap_gnome_property_box_append_page, METH_VARARGS|METH_KEYWORDS },
    { "set_state", (PyCFunction)_wrap_gnome_property_box_set_state, METH_VARARGS|METH_KEYWORDS },
    { NULL, NULL, 0 }
};

PyTypeObject PyGnomePropertyBox_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.PropertyBox",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    _PyGnomePropertyBox_methods,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_gnome_property_box_new,		/* tp_init */
};



/* ----------- GnomeScores ----------- */

PyTypeObject PyGnomeScores_Type = {
    PyObject_HEAD_INIT(NULL)
    0,					/* ob_size */
    "gnome.ui.Scores",			/* tp_name */
    sizeof(PyGObject),	        /* tp_basicsize */
    0,					/* tp_itemsize */
    /* methods */
    (destructor)0,			/* tp_dealloc */
    (printfunc)0,			/* tp_print */
    (getattrfunc)0,	/* tp_getattr */
    (setattrfunc)0,	/* tp_setattr */
    (cmpfunc)0,		/* tp_compare */
    (reprfunc)0,		/* tp_repr */
    0,			/* tp_as_number */
    0,		/* tp_as_sequence */
    0,			/* tp_as_mapping */
    (hashfunc)0,		/* tp_hash */
    (ternaryfunc)0,		/* tp_call */
    (reprfunc)0,		/* tp_str */
    (getattrofunc)0,			/* tp_getattro */
    (setattrofunc)0,			/* tp_setattro */
    0,					/* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /* tp_flags */
    NULL, 				/* Documentation string */
    (traverseproc)0,			/* tp_traverse */
    (inquiry)0,			/* tp_clear */
    (richcmpfunc)0,	/* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,		/* tp_iter */
    (iternextfunc)0,	/* tp_iternext */
    NULL,			/* tp_methods */
    0,					/* tp_members */
    0,		       	/* tp_getset */
    NULL,				/* tp_base */
    NULL,				/* tp_dict */
    (descrgetfunc)0,	/* tp_descr_get */
    (descrsetfunc)0,	/* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)pygobject_no_constructor,		/* tp_init */
};



/* ----------- functions ----------- */

static PyObject *
_wrap_gnome_about_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_about_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_appbar_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_appbar_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_app_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_app_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_accelerators_sync(PyObject *self)
{
    gnome_accelerators_sync();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_app_setup_toolbar(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "toolbar", "dock_item", NULL };
    PyGObject *toolbar, *dock_item;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!O!:gnome_app_setup_toolbar", kwlist, &PyGtkToolbar_Type, &toolbar, &PyBonoboDockItem_Type, &dock_item))
        return NULL;
    gnome_app_setup_toolbar(GTK_TOOLBAR(toolbar->obj), BONOBO_DOCK_ITEM(dock_item->obj));
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_client_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_client_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_master_client(PyObject *self)
{
    GnomeClient *ret;

    ret = gnome_master_client();
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_client_disable_master_connection(PyObject *self)
{
    gnome_client_disable_master_connection();
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_interaction_key_return(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "key", "cancel_shutdown", NULL };
    int key, cancel_shutdown;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ii:gnome_interaction_key_return", kwlist, &key, &cancel_shutdown))
        return NULL;
    gnome_interaction_key_return(key, cancel_shutdown);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_color_picker_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_color_picker_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_date_edit_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_date_edit_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_dialog_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_dialog_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_ok_dialog_parented(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "message", "parent", NULL };
    char *message;
    PyGObject *parent;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!:gnome_ok_dialog_parented", kwlist, &message, &PyGtkWindow_Type, &parent))
        return NULL;
    ret = gnome_ok_dialog_parented(message, GTK_WINDOW(parent->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_error_dialog(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "error", NULL };
    char *error;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:gnome_error_dialog", kwlist, &error))
        return NULL;
    ret = gnome_error_dialog(error);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_error_dialog_parented(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "error", "parent", NULL };
    char *error;
    PyGObject *parent;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!:gnome_error_dialog_parented", kwlist, &error, &PyGtkWindow_Type, &parent))
        return NULL;
    ret = gnome_error_dialog_parented(error, GTK_WINDOW(parent->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_warning_dialog(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "warning", NULL };
    char *warning;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:gnome_warning_dialog", kwlist, &warning))
        return NULL;
    ret = gnome_warning_dialog(warning);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_warning_dialog_parented(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "warning", "parent", NULL };
    char *warning;
    PyGObject *parent;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO!:gnome_warning_dialog_parented", kwlist, &warning, &PyGtkWindow_Type, &parent))
        return NULL;
    ret = gnome_warning_dialog_parented(warning, GTK_WINDOW(parent->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_druid_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_druid_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_druid_page_edge_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_druid_page_edge_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_druid_page_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_druid_page_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_druid_page_standard_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_druid_page_standard_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_entry_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_entry_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_file_entry_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_file_entry_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_font_picker_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_font_picker_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_href_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_href_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_icon_entry_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_icon_entry_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_icon_text_item_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_icon_text_item_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_icon_list_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_icon_list_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_icon_selection_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_icon_selection_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_mdi_child_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_mdi_child_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_mdi_generic_child_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_mdi_generic_child_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_mdi_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_mdi_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_mdi_get_app_from_view(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", NULL };
    PyGObject *view;
    GnomeApp *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:gnome_mdi_get_app_from_view", kwlist, &PyGtkWidget_Type, &view))
        return NULL;
    ret = gnome_mdi_get_app_from_view(GTK_WIDGET(view->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_mdi_get_child_from_view(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "view", NULL };
    PyGObject *view;
    GnomeMDIChild *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:gnome_mdi_get_child_from_view", kwlist, &PyGtkWidget_Type, &view))
        return NULL;
    ret = gnome_mdi_get_child_from_view(GTK_WIDGET(view->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_message_box_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_message_box_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_pixmap_entry_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_pixmap_entry_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_pixmap_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_pixmap_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_popup_menu_get_accel_group(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "menu", NULL };
    PyGObject *menu;
    GtkAccelGroup *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!:gnome_popup_menu_get_accel_group", kwlist, &PyGtkMenu_Type, &menu))
        return NULL;
    ret = gnome_popup_menu_get_accel_group(GTK_MENU(menu->obj));
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_property_box_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_property_box_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_scores_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_scores_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_scores_display_with_pixmap(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "pixmap_logo", "app_name", "level", "pos", NULL };
    char *pixmap_logo, *app_name, *level;
    int pos;
    GtkWidget *ret;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sssi:gnome_scores_display_with_pixmap", kwlist, &pixmap_logo, &app_name, &level, &pos))
        return NULL;
    ret = gnome_scores_display_with_pixmap(pixmap_logo, app_name, level, pos);
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_gnome_ui_info_configurable_types_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_ui_info_configurable_types_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_ui_pixmap_type_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_ui_pixmap_type_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_interact_style_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_interact_style_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_dialog_type_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_dialog_type_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_save_style_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_save_style_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_restart_style_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_restart_style_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_client_state_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_client_state_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_client_flags_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_client_flags_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_date_edit_flags_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_date_edit_flags_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_edge_position_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_edge_position_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_font_picker_mode_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_font_picker_mode_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_icon_list_mode_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_icon_list_mode_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_mdi_mode_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_mdi_mode_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_preferences_type_get_type(PyObject *self)
{
    GType ret;

    ret = gnome_preferences_type_get_type();
    return pyg_type_wrapper_new(ret);
}

static PyObject *
_wrap_gnome_window_icon_set_from_file(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "w", "filename", NULL };
    PyGObject *w;
    char *filename;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "O!s:gnome_window_icon_set_from_file", kwlist, &PyGtkWindow_Type, &w, &filename))
        return NULL;
    gnome_window_icon_set_from_file(GTK_WINDOW(w->obj), filename);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_window_icon_set_default_from_file(PyObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "filename", NULL };
    char *filename;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s:gnome_window_icon_set_default_from_file", kwlist, &filename))
        return NULL;
    gnome_window_icon_set_default_from_file(filename);
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_gnome_window_icon_init(PyObject *self)
{
    gnome_window_icon_init();
    Py_INCREF(Py_None);
    return Py_None;
}

PyMethodDef pyui_functions[] = {
    { "gnome_about_get_type", (PyCFunction)_wrap_gnome_about_get_type, METH_NOARGS },
    { "gnome_appbar_get_type", (PyCFunction)_wrap_gnome_appbar_get_type, METH_NOARGS },
    { "gnome_app_get_type", (PyCFunction)_wrap_gnome_app_get_type, METH_NOARGS },
    { "gnome_accelerators_sync", (PyCFunction)_wrap_gnome_accelerators_sync, METH_NOARGS },
    { "gnome_app_setup_toolbar", (PyCFunction)_wrap_gnome_app_setup_toolbar, METH_VARARGS|METH_KEYWORDS },
    { "gnome_client_get_type", (PyCFunction)_wrap_gnome_client_get_type, METH_NOARGS },
    { "gnome_master_client", (PyCFunction)_wrap_gnome_master_client, METH_NOARGS },
    { "gnome_client_disable_master_connection", (PyCFunction)_wrap_gnome_client_disable_master_connection, METH_NOARGS },
    { "gnome_interaction_key_return", (PyCFunction)_wrap_gnome_interaction_key_return, METH_VARARGS|METH_KEYWORDS },
    { "gnome_color_picker_get_type", (PyCFunction)_wrap_gnome_color_picker_get_type, METH_NOARGS },
    { "gnome_date_edit_get_type", (PyCFunction)_wrap_gnome_date_edit_get_type, METH_NOARGS },
    { "gnome_dialog_get_type", (PyCFunction)_wrap_gnome_dialog_get_type, METH_NOARGS },
    { "gnome_ok_dialog_parented", (PyCFunction)_wrap_gnome_ok_dialog_parented, METH_VARARGS|METH_KEYWORDS },
    { "gnome_error_dialog", (PyCFunction)_wrap_gnome_error_dialog, METH_VARARGS|METH_KEYWORDS },
    { "gnome_error_dialog_parented", (PyCFunction)_wrap_gnome_error_dialog_parented, METH_VARARGS|METH_KEYWORDS },
    { "gnome_warning_dialog", (PyCFunction)_wrap_gnome_warning_dialog, METH_VARARGS|METH_KEYWORDS },
    { "gnome_warning_dialog_parented", (PyCFunction)_wrap_gnome_warning_dialog_parented, METH_VARARGS|METH_KEYWORDS },
    { "gnome_druid_get_type", (PyCFunction)_wrap_gnome_druid_get_type, METH_NOARGS },
    { "gnome_druid_page_edge_get_type", (PyCFunction)_wrap_gnome_druid_page_edge_get_type, METH_NOARGS },
    { "gnome_druid_page_get_type", (PyCFunction)_wrap_gnome_druid_page_get_type, METH_NOARGS },
    { "gnome_druid_page_standard_get_type", (PyCFunction)_wrap_gnome_druid_page_standard_get_type, METH_NOARGS },
    { "gnome_entry_get_type", (PyCFunction)_wrap_gnome_entry_get_type, METH_NOARGS },
    { "gnome_file_entry_get_type", (PyCFunction)_wrap_gnome_file_entry_get_type, METH_NOARGS },
    { "gnome_font_picker_get_type", (PyCFunction)_wrap_gnome_font_picker_get_type, METH_NOARGS },
    { "gnome_href_get_type", (PyCFunction)_wrap_gnome_href_get_type, METH_NOARGS },
    { "gnome_icon_entry_get_type", (PyCFunction)_wrap_gnome_icon_entry_get_type, METH_NOARGS },
    { "gnome_icon_text_item_get_type", (PyCFunction)_wrap_gnome_icon_text_item_get_type, METH_NOARGS },
    { "gnome_icon_list_get_type", (PyCFunction)_wrap_gnome_icon_list_get_type, METH_NOARGS },
    { "gnome_icon_selection_get_type", (PyCFunction)_wrap_gnome_icon_selection_get_type, METH_NOARGS },
    { "gnome_mdi_child_get_type", (PyCFunction)_wrap_gnome_mdi_child_get_type, METH_NOARGS },
    { "gnome_mdi_generic_child_get_type", (PyCFunction)_wrap_gnome_mdi_generic_child_get_type, METH_NOARGS },
    { "gnome_mdi_get_type", (PyCFunction)_wrap_gnome_mdi_get_type, METH_NOARGS },
    { "gnome_mdi_get_app_from_view", (PyCFunction)_wrap_gnome_mdi_get_app_from_view, METH_VARARGS|METH_KEYWORDS },
    { "gnome_mdi_get_child_from_view", (PyCFunction)_wrap_gnome_mdi_get_child_from_view, METH_VARARGS|METH_KEYWORDS },
    { "gnome_message_box_get_type", (PyCFunction)_wrap_gnome_message_box_get_type, METH_NOARGS },
    { "gnome_pixmap_entry_get_type", (PyCFunction)_wrap_gnome_pixmap_entry_get_type, METH_NOARGS },
    { "gnome_pixmap_get_type", (PyCFunction)_wrap_gnome_pixmap_get_type, METH_NOARGS },
    { "gnome_popup_menu_get_accel_group", (PyCFunction)_wrap_gnome_popup_menu_get_accel_group, METH_VARARGS|METH_KEYWORDS },
    { "gnome_property_box_get_type", (PyCFunction)_wrap_gnome_property_box_get_type, METH_NOARGS },
    { "gnome_scores_get_type", (PyCFunction)_wrap_gnome_scores_get_type, METH_NOARGS },
    { "gnome_scores_display_with_pixmap", (PyCFunction)_wrap_gnome_scores_display_with_pixmap, METH_VARARGS|METH_KEYWORDS },
    { "gnome_ui_info_configurable_types_get_type", (PyCFunction)_wrap_gnome_ui_info_configurable_types_get_type, METH_NOARGS },
    { "gnome_ui_pixmap_type_get_type", (PyCFunction)_wrap_gnome_ui_pixmap_type_get_type, METH_NOARGS },
    { "gnome_interact_style_get_type", (PyCFunction)_wrap_gnome_interact_style_get_type, METH_NOARGS },
    { "gnome_dialog_type_get_type", (PyCFunction)_wrap_gnome_dialog_type_get_type, METH_NOARGS },
    { "gnome_save_style_get_type", (PyCFunction)_wrap_gnome_save_style_get_type, METH_NOARGS },
    { "gnome_restart_style_get_type", (PyCFunction)_wrap_gnome_restart_style_get_type, METH_NOARGS },
    { "gnome_client_state_get_type", (PyCFunction)_wrap_gnome_client_state_get_type, METH_NOARGS },
    { "gnome_client_flags_get_type", (PyCFunction)_wrap_gnome_client_flags_get_type, METH_NOARGS },
    { "gnome_date_edit_flags_get_type", (PyCFunction)_wrap_gnome_date_edit_flags_get_type, METH_NOARGS },
    { "gnome_edge_position_get_type", (PyCFunction)_wrap_gnome_edge_position_get_type, METH_NOARGS },
    { "gnome_font_picker_mode_get_type", (PyCFunction)_wrap_gnome_font_picker_mode_get_type, METH_NOARGS },
    { "gnome_icon_list_mode_get_type", (PyCFunction)_wrap_gnome_icon_list_mode_get_type, METH_NOARGS },
    { "gnome_mdi_mode_get_type", (PyCFunction)_wrap_gnome_mdi_mode_get_type, METH_NOARGS },
    { "gnome_preferences_type_get_type", (PyCFunction)_wrap_gnome_preferences_type_get_type, METH_NOARGS },
    { "gnome_window_icon_set_from_file", (PyCFunction)_wrap_gnome_window_icon_set_from_file, METH_VARARGS|METH_KEYWORDS },
    { "gnome_window_icon_set_default_from_file", (PyCFunction)_wrap_gnome_window_icon_set_default_from_file, METH_VARARGS|METH_KEYWORDS },
    { "gnome_window_icon_init", (PyCFunction)_wrap_gnome_window_icon_init, METH_NOARGS },
    { NULL, NULL, 0 }
};


/* ----------- enums and flags ----------- */

void
pyui_add_constants(PyObject *module, const gchar *strip_prefix)
{
    pyg_enum_add_constants(module, GNOME_TYPE_UI_INFO_TYPE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_UI_INFO_CONFIGURABLE_TYPES, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_UI_PIXMAP_TYPE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_INTERACT_STYLE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_DIALOG_TYPE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_SAVE_STYLE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_RESTART_STYLE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_CLIENT_STATE, strip_prefix);
    pyg_flags_add_constants(module, GNOME_TYPE_CLIENT_FLAGS, strip_prefix);
    pyg_flags_add_constants(module, GNOME_TYPE_DATE_EDIT_FLAGS, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_EDGE_POSITION, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_FONT_PICKER_MODE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_ICON_LIST_MODE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_MDI_MODE, strip_prefix);
    pyg_enum_add_constants(module, GNOME_TYPE_PREFERENCES_TYPE, strip_prefix);
}

/* intialise stuff extension classes */
void
pyui_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("bonobo.ui")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyBonoboDockItem_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "DockItem");
    } else {
        Py_FatalError("could not import bonobo.ui");
        return;
    }
    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
    } else {
        Py_FatalError("could not import gobject");
        return;
    }
    if ((module = PyImport_ImportModule("gtk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGtkObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Object");
        _PyGtkWidget_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Widget");
        _PyGtkBin_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Bin");
        _PyGtkContainer_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Container");
        _PyGtkHBox_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "HBox");
        _PyGtkVBox_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "VBox");
        _PyGtkWindow_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Window");
        _PyGtkDialog_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Dialog");
        _PyGtkButton_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Button");
        _PyGtkImage_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Image");
        _PyGtkMenu_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Menu");
        _PyGtkMenuBar_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "MenuBar");
        _PyGtkToolbar_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Toolbar");
        _PyGtkCombo_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Combo");
        _PyGtkAdjustment_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Adjustment");
        _PyGtkEditable_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Editable");
    } else {
        Py_FatalError("could not import gtk");
        return;
    }
    if ((module = PyImport_ImportModule("gtk.gdk")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGdkPixbuf_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Pixbuf");
    } else {
        Py_FatalError("could not import gtk.gdk");
        return;
    }
    if ((module = PyImport_ImportModule("gnome.canvas")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGnomeCanvas_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Canvas");
        _PyGnomeCanvasItem_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "CanvasItem");
    } else {
        Py_FatalError("could not import gnome.canvas");
        return;
    }


#line 6232 "ui.c"
    pygobject_register_class(d, "GnomeAbout", GNOME_TYPE_ABOUT, &PyGnomeAbout_Type, Py_BuildValue("(O)", &PyGtkDialog_Type));
    pygobject_register_class(d, "GnomeApp", GNOME_TYPE_APP, &PyGnomeApp_Type, Py_BuildValue("(O)", &PyGtkWindow_Type));
    pygobject_register_class(d, "GnomeAppBar", GNOME_TYPE_APPBAR, &PyGnomeAppBar_Type, Py_BuildValue("(O)", &PyGtkHBox_Type));
    pygobject_register_class(d, "GnomeClient", GNOME_TYPE_CLIENT, &PyGnomeClient_Type, Py_BuildValue("(O)", &PyGtkObject_Type));
    pygobject_register_class(d, "GnomeColorPicker", GNOME_TYPE_COLOR_PICKER, &PyGnomeColorPicker_Type, Py_BuildValue("(O)", &PyGtkButton_Type));
    pygobject_register_class(d, "GnomeDateEdit", GNOME_TYPE_DATE_EDIT, &PyGnomeDateEdit_Type, Py_BuildValue("(O)", &PyGtkHBox_Type));
    pygobject_register_class(d, "GnomeDialog", GNOME_TYPE_DIALOG, &PyGnomeDialog_Type, Py_BuildValue("(O)", &PyGtkWindow_Type));
    pygobject_register_class(d, "GnomeDruid", GNOME_TYPE_DRUID, &PyGnomeDruid_Type, Py_BuildValue("(O)", &PyGtkContainer_Type));
    pygobject_register_class(d, "GnomeDruidPage", GNOME_TYPE_DRUID_PAGE, &PyGnomeDruidPage_Type, Py_BuildValue("(O)", &PyGtkBin_Type));
    pygobject_register_class(d, "GnomeDruidPageEdge", GNOME_TYPE_DRUID_PAGE_EDGE, &PyGnomeDruidPageEdge_Type, Py_BuildValue("(O)", &PyGnomeDruidPage_Type));
    pygobject_register_class(d, "GnomeDruidPageStandard", GNOME_TYPE_DRUID_PAGE_STANDARD, &PyGnomeDruidPageStandard_Type, Py_BuildValue("(O)", &PyGnomeDruidPage_Type));
    pygobject_register_class(d, "GnomeEntry", GNOME_TYPE_ENTRY, &PyGnomeEntry_Type, Py_BuildValue("(O)", &PyGtkCombo_Type));
    pygobject_register_class(d, "GnomeFileEntry", GNOME_TYPE_FILE_ENTRY, &PyGnomeFileEntry_Type, Py_BuildValue("(O)", &PyGtkVBox_Type));
    pygobject_register_class(d, "GnomeFontPicker", GNOME_TYPE_FONT_PICKER, &PyGnomeFontPicker_Type, Py_BuildValue("(O)", &PyGtkButton_Type));
    pygobject_register_class(d, "GnomeHRef", GNOME_TYPE_HREF, &PyGnomeHRef_Type, Py_BuildValue("(O)", &PyGtkButton_Type));
    pygobject_register_class(d, "GnomeIconEntry", GNOME_TYPE_ICON_ENTRY, &PyGnomeIconEntry_Type, Py_BuildValue("(O)", &PyGtkVBox_Type));
    pygobject_register_class(d, "GnomeIconList", GNOME_TYPE_ICON_LIST, &PyGnomeIconList_Type, Py_BuildValue("(O)", &PyGnomeCanvas_Type));
    pygobject_register_class(d, "GnomeIconSelection", GNOME_TYPE_ICON_SELECTION, &PyGnomeIconSelection_Type, Py_BuildValue("(O)", &PyGtkVBox_Type));
    pygobject_register_class(d, "GnomeIconTextItem", GNOME_TYPE_ICON_TEXT_ITEM, &PyGnomeIconTextItem_Type, Py_BuildValue("(O)", &PyGnomeCanvasItem_Type));
    pygobject_register_class(d, "GnomeMDI", GNOME_TYPE_MDI, &PyGnomeMDI_Type, Py_BuildValue("(O)", &PyGtkObject_Type));
    pygobject_register_class(d, "GnomeMDIChild", GNOME_TYPE_MDI_CHILD, &PyGnomeMDIChild_Type, Py_BuildValue("(O)", &PyGtkObject_Type));
    pygobject_register_class(d, "GnomeMDIGenericChild", GNOME_TYPE_MDI_GENERIC_CHILD, &PyGnomeMDIGenericChild_Type, Py_BuildValue("(O)", &PyGnomeMDIChild_Type));
    pygobject_register_class(d, "GnomeMessageBox", GNOME_TYPE_MESSAGE_BOX, &PyGnomeMessageBox_Type, Py_BuildValue("(O)", &PyGnomeDialog_Type));
    pygobject_register_class(d, "GnomePixmap", GNOME_TYPE_PIXMAP, &PyGnomePixmap_Type, Py_BuildValue("(O)", &PyGtkImage_Type));
    pygobject_register_class(d, "GnomePixmapEntry", GNOME_TYPE_PIXMAP_ENTRY, &PyGnomePixmapEntry_Type, Py_BuildValue("(O)", &PyGnomeFileEntry_Type));
    pygobject_register_class(d, "GnomePropertyBox", GNOME_TYPE_PROPERTY_BOX, &PyGnomePropertyBox_Type, Py_BuildValue("(O)", &PyGnomeDialog_Type));
    pygobject_register_class(d, "GnomeScores", GNOME_TYPE_SCORES, &PyGnomeScores_Type, Py_BuildValue("(O)", &PyGtkDialog_Type));
}
